#include once "Gadget_DataGrid_Display.bas"
#include once "Gadget_ScrollBar.bas"
#include once "Gadget_String.bas"
namespace sGUI

declare function AddDataGrid (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer,GadHeight as integer, Editmode as integer=0) as Gadget ptr
declare function DGR_Actions(gad as Gadget ptr,action as integer) as integer
declare sub DGR_Update(gad as Gadget ptr)


'gui
declare sub DDisplayUpdate(gad as Gadget ptr)
declare sub TraceColumn(gad as Gadget ptr, ColumnID as integer)
declare sub TraceRow(gad as Gadget ptr, RowID as integer) 
declare sub TraceCell(gad as Gadget ptr, RowID as integer, ColumnID as integer)
'info
declare function GetSelectionMode(gad as Gadget ptr) as integer
declare function GetSelectedRow(gad as Gadget ptr) as integer
declare function GetSelectedColumn(gad as Gadget ptr) as integer
declare function GetNumRows(gad as Gadget ptr) as integer
declare function GetNumColumns(gad as Gadget ptr) as integer
'config
declare sub SetEditMode(gad as Gadget ptr, em as integer)
'edit grid
declare sub AddColumn(gad as Gadget ptr, cname as string, cwidth as integer=80)
declare sub AddRow(gad as Gadget ptr,numrows as integer=1)
declare sub DelColumn(gad as Gadget ptr, ColumnID as integer)
declare sub DelRow(gad as Gadget ptr, RowID as integer)
declare sub RowUp(gad as Gadget ptr, RowID as integer)
declare sub RowDown(gad as Gadget ptr, RowID as integer)
declare sub ColumnLeft(gad as Gadget ptr, ColumnID as integer)
declare sub ColumnRight(gad as Gadget ptr, ColumnID as integer)
declare sub ClearGrid(gad as Gadget ptr)
declare sub AutoWidth(gad as Gadget ptr, minwidth as integer=0, maxwidth as integer=0)
'cell edit i/o
declare sub SetCell(gad as Gadget ptr,RowID as integer,ColumnID as integer, text as string)
declare function GetCell(gad as Gadget ptr,RowID as integer,ColumnID as integer) as string
'file i/o
declare sub CSVLoad(gad as Gadget ptr, filename as string, mode as integer=0)
declare sub CSVSave(gad as Gadget ptr, filename as string, mode as integer=0)

/'
'Data Grid
type DGR_Data
	ColumnList 	          as sGUIList ptr
  RowList 	            as sGUIList ptr
	ddisplay     			    as _Gadget ptr
	vscroll 					    as _Gadget ptr
	hscroll 					    as _Gadget ptr
	edit    		          as _Gadget ptr  
  editmode              as integer
  focus                 as integer
  TimeStamp             as double   
end type
'/
function AddDataGrid(win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer,GadHeight as integer, Editmode as integer=0) as Gadget ptr
  function=0
  dim as Gadget ptr gad
	dim as ExtendedAction ptr xaction
  dim as integer editheight
  editheight=GetFontHeight(1) + 2*sGUIMainGap
  if win=0 then win=RootWindow
  gad=win->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
    gad->PosX=PosX
    gad->PosY=PosY
    gad->GadWidth=GadWidth
    gad->GadHeight=GadHeight
    
    gad->GadgetWindow=AddWindow(gad,0,0,gad->GadWidth,gad->GadHeight) 
    if gad->GadgetWindow then
      gad->GadgetWindow->Activation=1
      gad->xtd.dgr.edit       =AddStringGadget(gad->GadgetWindow,0,0,gad->GadWidth,,,1,,0) 
      '  SetSelect(gad->xtd.dgr.edit->xtd.stg.edit,0)
      '  SetString(gad->xtd.dgr.edit, "")  
      '  GadgetSleep(gad->xtd.dgr.edit)
      gad->xtd.dgr.ddisplay   =AddDataGridDisplay (gad->GadgetWindow,0,editheight + 1,gad->GadWidth - sGUIMainSize-1,gad->GadHeight - sGUIMainSize - editheight- 1 - 1)
      gad->xtd.dgr.hscroll		=AddScrollBar(gad->GadgetWindow,0,gad->GadHeight-sGUIMainSize,gad->GadWidth-sGUIMainSize-1,1,1,1,1,0)
      gad->xtd.dgr.vscroll    =AddScrollBar(gad->GadgetWindow,gad->GadWidth-sGUIMainSize,editheight + 1,gad->GadHeight-sGUIMainSize - editheight - 1 -1,1,1,1,1,1)	

      'aus dem ddisplay die Zeiger der Zeilen-/SpaltenInfoliste nach "oben" holen
      gad->xtd.dgr.ColumnList = gad->xtd.dgr.ddisplay->xtd.dtd.ColumnList 
      gad->xtd.dgr.RowList = gad->xtd.dgr.ddisplay->xtd.dtd.RowList
      
    end if	
    gad->xtd.dgr.EditMode=EditMode
    gad->DoAction   =@DGR_Actions
    gad->DoUpdate   =@DGR_Update
    
		function=gad
  end if
end function


function DGR_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
  dim as sGUIList ptr column
  dim as sGUIDGColumn ptr cinfo
  dim as sGUIDGCell ptr cell
  dim as sGUIList ptr row
  
  dim as Gadget ptr ddisplay,vscroll,hscroll,edit
 	dim as integer GadPosX,GadPosY,junk
  ddisplay=gad->xtd.dgr.ddisplay  
  vscroll=gad->xtd.dgr.vscroll
  hscroll=gad->xtd.dgr.hscroll
  edit=gad->xtd.dgr.edit
  
  select case action

    case GADGET_WHEELMOVE
      GetGlobalPosition(ddisplay,GadPosX,GadPosY)
      if (MOUSEX>=GadPosX) and (MOUSEX<GadPosX + ddisplay->GadWidth) and _
         (MOUSEY>=GadPosY) and (MOUSEY<GadPosY + ddisplay->GadHeight) then
        SetScrollBar(vscroll,GetScrollBar( vscroll ) + WHEEL )    
        SetViewPortRow(ddisplay,GetScrollBar(vscroll) )
        ddisplay->ReDraw=1
      end if 

    case GADGET_MOUSEHOVER
      gad->MouseHover=1       
    
    case GADGET_MOUSENEXT
      gad->MouseHover=0   

    case GADGET_LOOPTHROUGH
      if GADGETMESSAGE then       
        gad->xtd.dgr.focus=1
        
        select case GADGETMESSAGE            
          case edit
            print ddisplay->xtd.dtd.SelectionMode
            function=1
          
          case ddisplay
            function=1
            gad->xtd.dgr.TimeStamp=timer
            'SetSelect(edit->xtd.stg.edit,0)
            'SetString(gad->xtd.dgr.edit, "")  
            'GadgetSleep(edit)
            
            if gad->xtd.dgr.EditMode<>0 then
              select case gad->xtd.dgr.EditMode
                case 1'cell
                  if ddisplay->xtd.dtd.SelectionMode=4 then'...und auch nur eine Zelle selektiert ist
                    SetString(edit, ddisplay->xtd.dtd.SelectedCell->Text)
                    SetSelect(edit->xtd.stg.edit)
                    GadgetOn(edit)
                    ScrollToAnEnd (edit)
                  end if
                case 2'header
                  if ddisplay->xtd.dtd.SelectionMode=1 then'...und auch nur ein Header selektiert ist
                    SetString(edit, ddisplay->xtd.dtd.SelectedColumn->Text)               
                    SetSelect(edit->xtd.stg.edit)
                    GadgetOn(edit)
                    ScrollToAnEnd (edit)
                  end if
              end select
            end if
            
          case hscroll  
            SetViewPortColumn(ddisplay,GetScrollBar(hscroll) )
            ddisplay->ReDraw=1   
            
          case vscroll            
            SetViewPortRow(ddisplay,GetScrollBar(vscroll))
            ddisplay->ReDraw=1             
          
        end select
        
      end if

  end select
end function


sub DGR_Update(gad as Gadget ptr)
  dim as Gadget ptr ddisplay,vscroll,hscroll,edit
  dim as sGUIList ptr column
  dim as sGUIDGColumn ptr cinfo
  dim as sGUIDGCell ptr cell
  dim as sGUIList ptr row  
  dim as integer junk
  
  ddisplay=gad->xtd.dgr.ddisplay  
  vscroll=gad->xtd.dgr.vscroll
  hscroll=gad->xtd.dgr.hscroll
  edit=gad->xtd.dgr.edit

  if (LMB=HIT) and  (gad->xtd.dgr.focus>0) then
    gad->xtd.dgr.focus=0
    if GADGETMESSAGE=gad then gad->xtd.dgr.focus +=1
    if GADGETMESSAGE=ddisplay then gad->xtd.dgr.focus +=1
    if GADGETMESSAGE=vscroll then gad->xtd.dgr.focus +=1
    if GADGETMESSAGE=hscroll then gad->xtd.dgr.focus +=1
    if GADGETMESSAGE=edit then gad->xtd.dgr.focus +=1
    
    if gad->xtd.dgr.focus=0 then
      'GadgetSleep(edit)
      'SetSelect(edit->xtd.stg.edit,0)
      'SetString(gad->xtd.dgr.edit, "")    
    end if    
  end if

  
  if gad->xtd.dgr.focus then
    'Keyboardscrollregeln abhngig von Art der Selektion
    'das Scrollen erfolgt im ddisplay(childgad), aber dort werden die Zugriffe als Indizes gehndelt, warum jetzt auch immer ;)
    'auf dieser Ebene hier werden die Adressen daraus ermittelt und verwaltet    
    if KEY<>"" then
      
      if (ASCCODE=9) or (ASCCODE=13) then'nur bei TAB oder RETURN
        
        '1.Scrollen entsprechend SelektionsModus des Grids
        select case ddisplay->xtd.dtd.SelectionMode
          case 0                  
            ddisplay->xtd.dtd.SelectedColumn=0
            ddisplay->xtd.dtd.SelectedRow=0
            ddisplay->xtd.dtd.SelectedCell=0                         
          
          case 1
            'SpaltenScroll     
            if ASCCODE=9 then
              'Indexscroller im ddisplay
              ddisplay->xtd.dtd.SelectedColumnID +=1
              if ddisplay->xtd.dtd.SelectedColumnID>gad->xtd.dgr.ColumnList->NumNodes then ddisplay->xtd.dtd.SelectedColumnID=1                      
            end if             
            'nur Adresse Spalte  
            ddisplay->xtd.dtd.SelectedColumn=gad->xtd.dgr.ColumnList->GetAddr(ddisplay->xtd.dtd.SelectedColumnID)                
          
          case 2         
            'ZeilenScroll     
            if ASCCODE=13 then
              'Indexscroller im ddisplay          
              ddisplay->xtd.dtd.SelectedRowID +=1
              if ddisplay->xtd.dtd.SelectedRowID>gad->xtd.dgr.RowList->NumNodes then ddisplay->xtd.dtd.SelectedRowID=1
            end if
            'nur Adresse Zeile                 
            ddisplay->xtd.dtd.SelectedRow=gad->xtd.dgr.RowList->GetAddr(ddisplay->xtd.dtd.SelectedRowID)

          case 4
            'SpaltenScroll     
            if ASCCODE=9 then
              'Indexscroller im ddisplay 
              ddisplay->xtd.dtd.SelectedColumnID +=1
              if ddisplay->xtd.dtd.SelectedColumnID>gad->xtd.dgr.ColumnList->NumNodes then ddisplay->xtd.dtd.SelectedColumnID=1
            end if             
            'ZeilenScroll     
            if ASCCODE=13 then
              'Indexscroller im ddisplay 
              ddisplay->xtd.dtd.SelectedRowID +=1
              if ddisplay->xtd.dtd.SelectedRowID>gad->xtd.dgr.RowList->NumNodes then ddisplay->xtd.dtd.SelectedRowID=1
            end if
            'Adressen Spalte, Zeile und Zelle    
            ddisplay->xtd.dtd.SelectedColumn=gad->xtd.dgr.ColumnList->GetAddr(ddisplay->xtd.dtd.SelectedColumnID,ddisplay->xtd.dtd.SelectedColumn)                
            ddisplay->xtd.dtd.SelectedRow=gad->xtd.dgr.RowList->GetAddr(ddisplay->xtd.dtd.SelectedRowID,ddisplay->xtd.dtd.SelectedRow)
            ddisplay->xtd.dtd.SelectedCell=ddisplay->xtd.dtd.SelectedRow->GetAddr(ddisplay->xtd.dtd.SelectedColumnID)       
        end select 
        
        if ASCCODE=9 then TraceColumn(gad, ddisplay->xtd.dtd.SelectedColumnID)
        if ASCCODE=13 then TraceRow(gad, ddisplay->xtd.dtd.SelectedRowID)
        
        '2. Zelle/Header in StrinGadget kopieren
        'abhngig vom Editier/SelektionsModus des Grids
        select case gad->xtd.dgr.EditMode
          case 1'Zelle
            if ddisplay->xtd.dtd.SelectionMode=4 then
              SetString(edit, ddisplay->xtd.dtd.SelectedCell->Text)
              SetSelect(edit->xtd.stg.edit)
              GadgetOn(edit)
              ScrollToAnEnd (edit)             
            end if
        
          case 2'Header
            if ddisplay->xtd.dtd.SelectionMode=1 then
              SetString(edit, ddisplay->xtd.dtd.SelectedColumn->Text)               
              SetSelect(edit->xtd.stg.edit)
              GadgetOn(edit)
              ScrollToAnEnd (edit)        
            end if    
        end select       
      
      else'bei allen anderen Zeichen ausser TAB/RETURN 
      
        '3. Editieren und gleichzeitiges "Rckkopieren" in Zelle/Header
        'abhngig vom Editier/SelektionsModus des Grids
        select case gad->xtd.dgr.EditMode
          case 0
            'GadgetSleep(edit)
            'SetSelect(edit->xtd.stg.edit,0)
            'SetString(gad->xtd.dgr.edit, "")
          
          case 1'Zelle
            if ddisplay->xtd.dtd.SelectionMode=4 then
              junk=STG_KeyHandling(edit, KEY,ASCCODE,EXTENDED)        
              ddisplay->xtd.dtd.SelectedCell->Text = GetString(edit)
            end if
          case 2'Header
            if ddisplay->xtd.dtd.SelectionMode=1 then
              junk=STG_KeyHandling(edit, KEY,ASCCODE,EXTENDED)        
              ddisplay->xtd.dtd.SelectedColumn->Text = GetString(edit)               
            end if
        end select       
      end if    
      
    end if
    
    if KEY<>"" and ( (ASCCODE=9) or (ASCCODE=13) ) then GADGETMESSAGE=gad
    ddisplay->ReDraw=1
  end if
end sub


'gui **************************************************************************
sub DDisplayUpdate(gad as Gadget ptr) 
  dim as Gadget ptr ddisplay,vscroll,hscroll
  dim as integer h,v
  ddisplay=gad->xtd.dgr.ddisplay  
  vscroll=gad->xtd.dgr.vscroll
  hscroll=gad->xtd.dgr.hscroll 
  '????
  'if gad->xtd.dtd.ColumnList->NumNodes=0 then
  '  gad->xtd.dtd.RowList->DeleteAll
  'end if 
  
  h=GetScrollBar(hscroll)
  v=GetScrollBar(vscroll)
  SetLayout (ddisplay)
  SetScrollLimitsColumn(ddisplay) 
  SetScrollLimitsRow(ddisplay)
  SetViewPortColumn(ddisplay,h)
  SetViewPortRow(ddisplay,v)  
  'GUI aktualisieren
  'Parameter SetScrollBar: (gad as Gadget ptr,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer=0)
  SetScrollBar (hscroll,ddisplay->xtd.dtd.MinLower_ColumnID,ddisplay->xtd.dtd.MaxHigher_ColumnID,h,1)
  SetScrollBar (vscroll,ddisplay->xtd.dtd.MinLower_RowID,ddisplay->xtd.dtd.MaxHigher_RowID,v,1)  
  gad->xtd.dgr.ddisplay->ReDraw=1
end sub


sub TraceColumn(gad as Gadget ptr, ColumnID as integer)
  dim as Gadget ptr ddisplay,hscroll
  ddisplay=gad->xtd.dgr.ddisplay  
  hscroll=gad->xtd.dgr.hscroll
  SetViewPortColumn(ddisplay,ColumnID)
  SetScrollBar (hscroll,ColumnID)  
  ddisplay->ReDraw=1     
end sub


sub TraceRow(gad as Gadget ptr, RowID as integer)
  dim as Gadget ptr ddisplay,vscroll
  ddisplay=gad->xtd.dgr.ddisplay  
  vscroll=gad->xtd.dgr.vscroll
  SetViewPortRow(ddisplay,RowID)
  SetScrollBar (vscroll,RowID)  
  ddisplay->ReDraw=1 
end sub


sub TraceCell(gad as Gadget ptr, RowID as integer, ColumnID as integer)
  dim as Gadget ptr ddisplay
  ddisplay=gad->xtd.dgr.ddisplay   
  TraceColumn(gad, ColumnID)
  TraceRow(gad, RowID)
end sub


'info *************************************************************************
function GetSelectionMode(gad as Gadget ptr) as integer
  function=gad->xtd.dgr.ddisplay->xtd.dtd.SelectionMode
end function


function GetSelectedRow(gad as Gadget ptr) as integer
  function=gad->xtd.dgr.ddisplay->xtd.dtd.SelectedRowID
end function


function GetSelectedColumn(gad as Gadget ptr) as integer
  function=gad->xtd.dgr.ddisplay->xtd.dtd.SelectedColumnID
end function


function GetNumRows(gad as Gadget ptr) as integer
  function=gad->xtd.dgr.RowList->NumNodes
end function


function GetNumColumns(gad as Gadget ptr) as integer
  function=gad->xtd.dgr.ColumnList->NumNodes
end function


'config ***********************************************************************
sub SetEditMode(gad as Gadget ptr, em as integer)
  dim as Gadget ptr ddisplay,vscroll,hscroll,edit
  ddisplay=gad->xtd.dgr.ddisplay  
  vscroll=gad->xtd.dgr.vscroll
  hscroll=gad->xtd.dgr.hscroll
  edit=gad->xtd.dgr.edit  
  
  gad->xtd.dgr.EditMode=em
  
  if gad->xtd.dgr.EditMode=0 then
    GadgetSleep(edit)
    SetSelect(edit->xtd.stg.edit,0)
    SetString(gad->xtd.dgr.edit, "")
  else
    GadgetOn(edit)
    SetSelect(edit->xtd.stg.edit)
  end if
end sub


'edit grid *********************************************************************
sub AddColumn(gad as Gadget ptr, cname as string, cwidth as integer=80)
  dim as Gadget ptr ddisplay,hscroll
  ddisplay=gad->xtd.dgr.ddisplay  
  hscroll=gad->xtd.dgr.hscroll
  'cname &= " " & str(gad->xtd.dgr.ColumnList->NumNodes + 1)
  CreateColumn(ddisplay,cname,cwidth)
  SetLayout (ddisplay)  
  SetScrollLimitsColumn(ddisplay) 
  SetViewPortColumn(ddisplay,ddisplay->xtd.dtd.MaxHigher_ColumnID)
  'Parameter SetScrollBar: (gad as Gadget ptr,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer=0)
  SetScrollBar (hscroll,ddisplay->xtd.dtd.MinLower_ColumnID,ddisplay->xtd.dtd.MaxHigher_ColumnID,ddisplay->xtd.dtd.MaxHigher_ColumnID,1)  
end sub


sub AddRow(gad as Gadget ptr,numrows as integer=1)
  dim as Gadget ptr ddisplay,vscroll
  ddisplay=gad->xtd.dgr.ddisplay  
  vscroll=gad->xtd.dgr.vscroll
  CreateRow(ddisplay,numrows)
  SetLayout (ddisplay)  
  SetScrollLimitsRow(ddisplay) 
  SetViewPortRow(ddisplay,ddisplay->xtd.dtd.MaxHigher_RowID)
  'Parameter SetScrollBar: (gad as Gadget ptr,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer=0)
  SetScrollBar (vscroll,ddisplay->xtd.dtd.MinLower_RowID,ddisplay->xtd.dtd.MaxHigher_RowID,ddisplay->xtd.dtd.MaxHigher_RowID,1) 
end sub


sub DelColumn(gad as Gadget ptr, ColumnID as integer)
  dim as sGUIDGCell ptr cell
  dim as sGUIList ptr row
  dim as sGUIDGColumn ptr cinfo
  dim as Gadget ptr ddisplay,hscroll,vscroll
  ddisplay=gad->xtd.dgr.ddisplay  
  hscroll=gad->xtd.dgr.hscroll
  vscroll=gad->xtd.dgr.vscroll
  
  if (ColumnID>0) and (ColumnID<=gad->xtd.dgr.ColumnList->NumNodes) then
    
    cinfo=gad->xtd.dgr.ColumnList->GetAddr(ColumnID)
    gad->xtd.dgr.ColumnList->DeleteNode(cinfo)
    
    row=gad->xtd.dgr.RowList->GetFirst
    if row then
      do
        cell=row->GetAddr(ColumnID)
        row->DeleteNode(cell) 
        row=cast(sGUIList ptr,row->next_node)
      loop until row=0
    end if
    
    ddisplay->xtd.dtd.SelectionMode   =0
    ddisplay->xtd.dtd.SelectedColumn  =0
    ddisplay->xtd.dtd.SelectedColumnID=0
    ddisplay->xtd.dtd.SelectedRow     =0
    ddisplay->xtd.dtd.SelectedRowID   =0
    ddisplay->xtd.dtd.SelectedCell    =0      
    SetLayout (ddisplay)  
    SetScrollLimitsColumn(ddisplay) 
    SetViewPortColumn(ddisplay,ColumnID)
    'Parameter SetScrollBar: (gad as Gadget ptr,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer=0)
    SetScrollBar (hscroll,ddisplay->xtd.dtd.MinLower_ColumnID,ddisplay->xtd.dtd.MaxHigher_ColumnID,ColumnID,1) 

    if gad->xtd.dgr.ColumnList->NumNodes=0 then'sollte keine Spalte mehr existieren, dann auch Zeilendefinitionen lschen
      gad->xtd.dgr.RowList->DeleteAll
      SetScrollLimitsRow(ddisplay) 
      SetViewPortRow(ddisplay)
      'Parameter SetScrollBar: (gad as Gadget ptr,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer=0)
      SetScrollBar (vscroll,ddisplay->xtd.dtd.MinLower_RowID,ddisplay->xtd.dtd.MaxHigher_RowID,1,1)             
    end if
    
    ddisplay->ReDraw=1 
  end if 
end sub


sub DelRow(gad as Gadget ptr, RowID as integer)
  dim as sGUIList ptr row
  dim as Gadget ptr ddisplay,vscroll
  ddisplay=gad->xtd.dgr.ddisplay  
  vscroll=gad->xtd.dgr.vscroll
  
  if (RowID>0) and (RowID<=gad->xtd.dgr.RowList->NumNodes) then
    row=gad->xtd.dgr.RowList->GetAddr(RowID , ddisplay->xtd.dtd.VPLower_Row)   
    gad->xtd.dgr.RowList->DeleteNode(row)
      
    ddisplay->xtd.dtd.SelectionMode   =0
    ddisplay->xtd.dtd.SelectedColumn  =0
    ddisplay->xtd.dtd.SelectedColumnID=0
    ddisplay->xtd.dtd.SelectedRow     =0
    ddisplay->xtd.dtd.SelectedRowID   =0
    ddisplay->xtd.dtd.SelectedCell    =0      
    SetLayout (ddisplay)  
    SetScrollLimitsRow(ddisplay) 
    SetViewPortRow(ddisplay,RowID)
    'Parameter SetScrollBar: (gad as Gadget ptr,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer=0)
    SetScrollBar (vscroll,ddisplay->xtd.dtd.MinLower_RowID,ddisplay->xtd.dtd.MaxHigher_RowID,RowID,1) 
    ddisplay->ReDraw=1   
  end if
end sub


sub RowUp(gad as Gadget ptr, RowID as integer)
  dim as Gadget ptr ddisplay
  dim as sGUIList ptr row,dest
  ddisplay=gad->xtd.dgr.ddisplay  
  if RowID>1 then'schliesst keine Zeilenselektion(=0) und den Fall das Zeile schon 1. Position hat aus
    row=gad->xtd.dgr.RowList->GetAddr(RowID,ddisplay->xtd.dtd.VPLower_Row)
    dest=gad->xtd.dgr.RowList->GetAddr(RowID-1,row)
    gad->xtd.dgr.RowList->MoveBefore(row,dest)
    ddisplay->xtd.dtd.SelectedRowID -=1
    'SetVisibles(ddisplay)        
    SetViewPortColumn(ddisplay)
    SetViewPortRow(ddisplay)
    ddisplay->ReDraw=1
  end if
end sub


sub RowDown(gad as Gadget ptr, RowID as integer)
  dim as Gadget ptr ddisplay
  dim as sGUIList ptr row,dest
  ddisplay=gad->xtd.dgr.ddisplay  
  if (RowID>0) and (RowID<gad->xtd.dgr.RowList->NumNodes) then'schliesst keine Zeilenselektion(=0) und den Fall das Zeile schon die letzte ist aus
    row=gad->xtd.dgr.RowList->GetAddr(RowID,ddisplay->xtd.dtd.VPLower_Row)
    dest=gad->xtd.dgr.RowList->GetAddr(RowID+1,row)
    gad->xtd.dgr.RowList->MoveBehind(row,dest)
    ddisplay->xtd.dtd.SelectedRowID +=1
    'SetVisibles(ddisplay)        
    SetViewPortColumn(ddisplay)
    SetViewPortRow(ddisplay)
    ddisplay->ReDraw=1
  end if
end sub


sub ColumnLeft(gad as Gadget ptr, ColumnID as integer)
  dim as sGUIDGCell ptr cell,dest
  dim as sGUIList ptr row
  dim as sGUIDGColumn ptr cinfo,cinfodest
  dim as Gadget ptr ddisplay,vscroll,hscroll
  ddisplay=gad->xtd.dgr.ddisplay  
  vscroll=gad->xtd.dgr.vscroll
  hscroll=gad->xtd.dgr.hscroll
  if ColumnID>1 then'schliesst keine Spaltenselektion(=0) und den Fall das Spalte schon 1. Position hat aus  
    cinfo=gad->xtd.dgr.ColumnList->GetAddr(ColumnID)
    cinfodest=gad->xtd.dgr.ColumnList->GetAddr(ColumnID-1,cinfo)
    gad->xtd.dgr.ColumnList->MoveBefore(cinfo,cinfodest)
    row=gad->xtd.dgr.RowList->GetFirst
    if row then
      do
        cell=row->GetAddr(ColumnID)
        dest=row->GetAddr(ColumnID-1,cell)
        row->MoveBefore(cell,dest)
        row=cast(sGUIList ptr,row->next_node)
      loop until row=0
    end if
    ddisplay->xtd.dtd.SelectedColumnID -=1
    DDisplayUpdate(gad) 
  end if
end sub


sub ColumnRight(gad as Gadget ptr, ColumnID as integer)
  dim as sGUIDGCell ptr cell,dest
  dim as sGUIList ptr row
  dim as sGUIDGColumn ptr cinfo,cinfodest
  dim as Gadget ptr ddisplay,vscroll,hscroll
  ddisplay=gad->xtd.dgr.ddisplay  
  vscroll=gad->xtd.dgr.vscroll
  hscroll=gad->xtd.dgr.hscroll
  if (ColumnID>0) and (ColumnID<gad->xtd.dgr.ColumnList->NumNodes) then'schliesst keine Spaltenselektion(=0) und den Fall das Spalte schon die letzte ist aus    
    cinfo=gad->xtd.dgr.ColumnList->GetAddr(ColumnID)
    cinfodest=gad->xtd.dgr.ColumnList->GetAddr(ColumnID+1,cinfo)
    gad->xtd.dgr.ColumnList->MoveBehind(cinfo,cinfodest)
    row=gad->xtd.dgr.RowList->GetFirst
    if row then
      do
        cell=row->GetAddr(ColumnID)
        dest=row->GetAddr(ColumnID+1,cell)
        row->MoveBehind(cell,dest)
        row=cast(sGUIList ptr,row->next_node)
      loop until row=0
    end if
    ddisplay->xtd.dtd.SelectedColumnID +=1
    DDisplayUpdate(gad) 
  end if
end sub


sub ClearGrid(gad as Gadget ptr)
  dim as Gadget ptr ddisplay,vscroll,hscroll
  ddisplay=gad->xtd.dgr.ddisplay  
  vscroll=gad->xtd.dgr.vscroll
  hscroll=gad->xtd.dgr.hscroll
  
  gad->xtd.dgr.RowList->DeleteAll
  gad->xtd.dgr.ColumnList->DeleteAll
  
  ddisplay->xtd.dtd.SelectionMode=0
  ddisplay->xtd.dtd.SelectedRowID=0
  ddisplay->xtd.dtd.SelectedColumnID=0
  ddisplay->xtd.dtd.SelectedCell=0   
  DDisplayUpdate(gad)
end sub


sub AutoWidth(gad as Gadget ptr, minwidth as integer=0, maxwidth as integer=0)
  dim as sGUIDGCell ptr cell
  dim as sGUIList ptr row
  dim as sGUIDGColumn ptr cinfo
  dim as integer cellwidth  
  dim as Gadget ptr ddisplay,vscroll,hscroll
  ddisplay=gad->xtd.dgr.ddisplay  
  vscroll=gad->xtd.dgr.vscroll
  hscroll=gad->xtd.dgr.hscroll
 
  if (maxwidth=0) or (maxwidth>ddisplay->xtd.dtd.GrdWidth - 10) then maxwidth=ddisplay->xtd.dtd.GrdWidth - 10'Korrekturpixel notwendig?
  if minwidth>maxwidth then swap minwidth,maxwidth    
  
  if gad->xtd.dgr.ColumnList->NumNodes then
    cinfo=gad->xtd.dgr.ColumnList->GetFirst
    do
      cinfo->ColumnWidth=GetTextWidth(cinfo->Text,2) + 2*sGUIMainGap
      if minwidth then
        if cinfo->ColumnWidth<minwidth then cinfo->ColumnWidth=minwidth
      end if
      if cinfo->ColumnWidth>maxwidth then cinfo->ColumnWidth=maxwidth      
      cinfo=cast(sGUIDGColumn ptr,cinfo->next_node)
    loop until cinfo=0
    
    if gad->xtd.dgr.RowList->NumNodes then
    row=gad->xtd.dgr.RowList->GetFirst
      do       
        cell=row->GetFirst
        cinfo=gad->xtd.dgr.ColumnList->GetFirst
        do
          cellwidth=GetTextWidth(cell->Text,2) + 2*sGUIMainGap
          if cellwidth>cinfo->ColumnWidth then cinfo->ColumnWidth=cellwidth
          if cinfo->ColumnWidth>maxwidth then cinfo->ColumnWidth=maxwidth     
          cell=cast(sGUIDGCell ptr,cell->next_node)
          cinfo=cast(sGUIDGColumn ptr,cinfo->next_node)
        loop until cell=0
        
        row=cast(sGUIList ptr,row->next_node)
      loop until row=0    
    end if
  end if
  DDisplayUpdate(gad)
end sub


'cell edit i/o *****************************************************************
sub SetCell(gad as Gadget ptr,RowID as integer,ColumnID as integer, text as string)
  dim as sGUIDGCell ptr cell 
  cell=GetCellAddr(gad->xtd.dgr.ddisplay,RowID,ColumnID)
  if cell then cell->Text=text
end sub


function GetCell(gad as Gadget ptr,RowID as integer,ColumnID as integer) as string
  dim as sGUIDGCell ptr cell 
  cell=GetCellAddr(gad->xtd.dgr.ddisplay,RowID,ColumnID)
  if cell then function=cell->Text else function=""
end function


'file i/o **********************************************************************
sub CSVLoad(gad as Gadget ptr, filename as string, mode as integer=0)
  dim as integer ff,comma,commaold,lenrow,lenpart,exitsignal,txtwidth,maxwidth
  dim as string rowtxt,celltxt,hdrtxt
  dim as sGUIDGCell ptr cell
  dim as sGUIList ptr row
  dim as sGUIDGColumn ptr cinfo
  dim as Gadget ptr ddisplay,vscroll,hscroll
  ddisplay=gad->xtd.dgr.ddisplay  
  vscroll=gad->xtd.dgr.vscroll
  hscroll=gad->xtd.dgr.hscroll
  maxwidth=ddisplay->xtd.dtd.GrdWidth-sGUIMainSize
  ClearGrid(gad)
  ff=freefile
  open filename for input as ff
    'Header einlesen in ColumnList, Spalte erzeugen
    line input #ff, rowtxt
    lenrow=len(rowtxt)
    comma=0
    do
      commaold=comma
      comma = instr(commaold + 1, rowtxt, ",")
      if comma<>0 then lenpart=comma - commaold -1 else lenpart=lenrow - commaold         
      hdrtxt=mid(rowtxt,commaold+1,lenpart)
      CreateColumn(ddisplay, hdrtxt,GetTextWidth(hdrtxt,2)+ 2*sGUIMainGap)     
    loop until comma=0

    select case mode
    
      case 0'neues Grid aus CSV, komplett geladen mit fester Spaltenbreite
        
        'Datenzeilen einlesen in RowList, Zeilen und Zellen erzeugen
        'es wird nicht berprft ob Zellenanzahl jeder Zeile gleich der Spaltenanzahl entspricht
        'wir gehen davon aus dass die CSV "gltig" ist
        'Line Input geht nicht, wegen Komma im Zelltext
        do
          row=gad->xtd.dgr.RowList->AppendNew(sGUIListType)
          cinfo=gad->xtd.dgr.ColumnList->GetFirst
          for i as integer=1 to gad->xtd.dgr.ColumnList->NumNodes' hier direkt aus ColumnList geholt, da oben frisch gendert
            input #ff,celltxt
            cell=row->AppendNew(sGUIDGCellType)
            if cell then
              cell->Text=celltxt
              txtwidth=GetTextWidth(celltxt,2)+ 2*sGUIMainGap
              if txtwidth>cinfo->ColumnWidth then cinfo->ColumnWidth=txtwidth
              if cinfo->ColumnWidth>maxwidth then cinfo->ColumnWidth=maxwidth
            end if
            
            cinfo=cast(sGUIDGColumn ptr,cinfo->next_node)            
          next i
        loop until eof(ff)         

    end select
    
  close ff
  
  DDisplayUpdate(gad)
end sub


sub CSVSave(gad as Gadget ptr, filename as string, mode as integer=0)
  dim as integer ff
  dim as sGUIDGCell ptr cell
  dim as sGUIList ptr row
  dim as sGUIDGColumn ptr cinfo
  dim as Gadget ptr ddisplay
  ddisplay=gad->xtd.dgr.ddisplay    
  
  ff=freefile
  open filename for output as ff  
      
    if gad->xtd.dgr.ColumnList->NumNodes then'wenn es Spalten gibt, aktiv werden, Hauptbedingung!!!
    
      'Header schreiben
      cinfo=gad->xtd.dgr.ColumnList->GetFirst
      do
        print #ff,cinfo->Text;
        cinfo=cast(sGUIDGColumn ptr,cinfo->next_node)
        if cinfo<>0 then print #ff,",";
      loop until cinfo=0
      print #ff,
      
      'Daten schreiben
      select case mode     
        case 0'aus den Daten ein "normale" CSV Datei erzeugen          
          if gad->xtd.dgr.RowList->NumNodes then'wenn es Zeilen gibt          
            row=gad->xtd.dgr.RowList->GetFirst
            do
              cell=row->GetFirst
              do
                if instr(cell->Text,",") then cell->Text =chr(34) & cell->Text & chr(34)'falls Komma im String, selbigen in Anfhrungszeichen setzen
                print #ff, cell->Text;                   
                cell=cast(sGUIDGCell ptr,cell->next_node)
                if cell<>0 then print #ff, ",";
              loop until cell=0
              row=cast(sGUIList ptr,row->next_node)
              if row<>0 then print #ff,         
            loop until row=0
          end if
        /'
        case 1'Config CSV, Daten enthalten Spaltenbreiten
          if gad->xtd.dgr.ColumnList->NumNodes then'wenn es Spalten gibt      
            cinfo=gad->xtd.dgr.ColumnList->GetFirst
            do
              print #ff,cinfo->ColumnWidth;
              cinfo=cast(sGUIDGColumn ptr,cinfo->next_node)
              if cinfo<>0 then print #ff,",";
            loop until cinfo=0
          end if        
        '/
      end select
    
    end if   
  close ff
end sub


end namespace
