namespace sGUI

declare function AddDataGridDisplay (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer,GadHeight as integer) as Gadget ptr
declare function DTD_Actions(gad as Gadget ptr,action as integer) as integer
declare sub DTD_Draw (gad as Gadget ptr)

declare sub SetLayout (gad as Gadget ptr)
declare sub SetScrollLimitsColumn (gad as Gadget ptr)
declare sub SetScrollLimitsRow (gad as Gadget ptr)
declare sub SetViewPortColumn(gad as Gadget ptr, target as integer=0)  
declare sub SetViewPortRow(gad as Gadget ptr, target as integer=0) 

declare sub CreateColumn(gad as Gadget ptr, cname as string, cwidth as integer=80)
declare sub CreateRow(gad as Gadget ptr,num as integer=1)
declare function GetSelColumn(gad as Gadget ptr, GadPosX as integer, GadPosY as integer) as integer
declare function GetSelRow(gad as Gadget ptr, GadPosX as integer, GadPosY as integer) as integer
declare function GetRowAddr(gad as Gadget ptr, rowid as integer) as _sGUIList ptr
declare function GetCellAddr(gad as Gadget ptr, rowid as integer, columnid as integer) as _sGUIDGCell ptr
/'
'Data Grid_Display
type DTD_Data
	ColumnList 	          as sGUIList ptr
  RowList 	            as sGUIList ptr

  CellHeight            as integer 'Festwert gesetzt durch AddDataGridDisplay 
  
  InfoPosX              as integer 'Festwert gesetzt durch AddDataGridDisplay
  InfoPosY              as integer 'Festwert gesetzt durch AddDataGridDisplay
  InfoHeight            as integer 'Festwert gesetzt durch AddDataGridDisplay
  GrdPosY               as integer 'Festwert gesetzt durch AddDataGridDisplay
  GrdHeight             as integer 'Festwert gesetzt durch AddDataGridDisplay  
  InfoWidth             as integer 'aktualisiert durch SetLayout  
  
  GrdPosX               as integer 'aktualisiert durch SetLayout   
  GrdWidth              as integer 'aktualisiert durch SetLayout
  
  'ZeilenViewPort
  VPLower_Row           as sGUIList ptr 'aktualisiert vom Scrollbar und SetVisibles
  VPLower_RowID         as integer               
  VPHigher_Row          as _sGUIList ptr
  VPHigher_RowID        as integer
  VPNumRows             as integer
  
  'ColumnViewPort      
  VPLower_Column          as _sGUIDGColumn ptr 'aktualisiert vom Scrollbar und SetVisibles
  VPLower_ColumnID        as integer                    
  VPHigher_Column        as _sGUIDGColumn ptr
  VPHigher_ColumnID      as integer
  VPNumColumns           as integer
  
  'Spalten Min/Max
  MinLower_Column         as _sGUIDGColumn ptr'aktualisiert von SetScrollLimitsColumn  
  MinLower_ColumnID       as integer          
  MinHigher_Column        as _sGUIDGColumn ptr 
  MinHigher_ColumnID      as integer           
  MinNumColumns           as integer  
  MaxLower_Column         as _sGUIDGColumn ptr
  MaxLower_ColumnID       as integer          
  MaxHigher_Column        as _sGUIDGColumn ptr
  MaxHigher_ColumnID      as integer           
  MaxNumColumns           as integer  

  'Zeilen Min/Max
  MinLower_Row          as _sGUIList ptr'aktualisiert von SetScrollLimitsRow  
  MinLower_RowID        as integer     
  MinHigher_Row         as _sGUIList ptr
  MinHigher_RowID       as integer     
  MinNumRows            as integer
  MaxLower_Row          as _sGUIList ptr
  MaxLower_RowID        as integer     
  MaxHigher_Row         as _sGUIList ptr
  MaxHigher_RowID       as integer      
  MaxNumRows            as integer  

  SelectionMode       as integer
  SelectedColumn      as _sGUIDGColumn ptr
  SelectedColumnID    as integer
  SelectedRow         as _sGUIList ptr
  SelectedRowID       as integer  
  SelectedCell        as _sGUIDGCell ptr

  EditPosXglobal      as integer
  EditPosYglobal      as integer  
  TimeStamp           as double   
end type
'/
function AddDataGridDisplay (win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer,GadHeight as integer) as Gadget ptr  
  function=0  
  dim as Gadget ptr gad
  dim as integer cellheight,fillwidth
  
  if win=0 then win=RootWindow
  gad=win->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
    gad->PosX=PosX
    gad->PosY=PosY
		gad->GadWidth=GadWidth
		gad->GadHeight=GadHeight     
    
    gad->xtd.dtd.ColumnList = EntryLists->AppendNew (sGUIListType)    
    gad->xtd.dtd.RowList = CellLists->AppendNew (sGUIListType)  
    gad->xtd.dtd.CellHeight=GetFontHeight(2) + 2*sGUIMainGap    
       
    gad->xtd.dtd.InfoPosX=1
    gad->xtd.dtd.InfoPosY=1    
    gad->xtd.dtd.InfoWidth=GetTextWidth(str("99"), 2) + 2*sGUIMainGap
    gad->xtd.dtd.InfoHeight=gad->xtd.dtd.CellHeight    
        
    gad->xtd.dtd.GrdPosX=gad->xtd.dtd.InfoPosX + gad->xtd.dtd.InfoWidth
    gad->xtd.dtd.GrdPosY=gad->xtd.dtd.InfoPosY + gad->xtd.dtd.InfoHeight        
    gad->xtd.dtd.GrdWidth=gad->GadWidth - gad->xtd.dtd.GrdPosX - 1
    gad->xtd.dtd.GrdHeight=gad->GadHeight - gad->xtd.dtd.GrdPosY - 1  
    
    gad->xtd.dtd.VPNumRows=int(gad->xtd.dtd.GrdHeight/gad->xtd.dtd.CellHeight)
    SetLayout (gad)
    'SetVisibles(gad)
    SetViewPortColumn(gad,1)
    SetViewPortRow(gad,1)
    SetScrollLimitsColumn(gad) 
    SetScrollLimitsRow(gad)
    
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight)
    gad->DoDraw      =@DTD_Draw
    gad->DoAction    =@DTD_Actions
    'gad->DoUpdate	   =@DTD_Update    
		function=gad
  end if
end function


function DTD_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
 	dim as integer GadPosX,GadPosY,fail 
  dim as sGUIDGColumn ptr cinfo
  dim as sGUIDGCell ptr cell
  dim as sGUIList ptr row
  
  select case action
    case GADGET_LMBHIT 
      GetGlobalPosition(gad,GadPosX,GadPosY)  
      gad->xtd.dtd.SelectionMode=0

      'Spaltenbereich
      if (MOUSEX>=GadPosX + gad->xtd.dtd.GrdPosX) and (MOUSEX<GadPosX + gad->GadWidth - 1) and _
         (MOUSEY>=GadPosY + gad->xtd.dtd.InfoPosY) and (MOUSEY<GadPosY + gad->xtd.dtd.InfoPosY + gad->xtd.dtd.InfoHeight) then
         gad->xtd.dtd.SelectionMode=1
      end if
      'Zeilennummerbereich
      if (MOUSEX>=GadPosX + gad->xtd.dtd.InfoPosX) and (MOUSEX<GadPosX + gad->xtd.dtd.InfoPosX + gad->xtd.dtd.InfoWidth) and _
         (MOUSEY>=GadPosY + gad->xtd.dtd.InfoPosY + gad->xtd.dtd.InfoHeight) and (MOUSEY<GadPosY + gad->xtd.dtd.InfoPosY + gad->GadHeight - 1) then
         gad->xtd.dtd.SelectionMode=2
      end if
      'Zellenbereich
      if (MOUSEX>=(GadPosX + gad->xtd.dtd.GrdPosX)) and (MOUSEX<(GadPosX + gad->xtd.dtd.GrdPosX + gad->xtd.dtd.GrdWidth)) and _
         (MOUSEY>=(GadPosY + gad->xtd.dtd.GrdPosY)) and (MOUSEY<(GadPosY + gad->xtd.dtd.GrdPosY + gad->xtd.dtd.GrdHeight)) then
         gad->xtd.dtd.SelectionMode=4
      end if

      if gad->xtd.dtd.SelectionMode then
        gad->xtd.dtd.SelectedRowID=0
        gad->xtd.dtd.SelectedColumnID=0
        gad->xtd.dtd.SelectedCell=0        
        fail=0
        select case gad->xtd.dtd.SelectionMode
          case 1
            fail+=GetSelColumn(gad, GadPosX, GadPosY)
            gad->xtd.dtd.EditPosYGlobal=GadPosY + gad->xtd.dtd.InfoPosY
          case 2
            fail+=GetSelRow(gad, GadPosX, GadPosY)
          case 4
            fail+=GetSelColumn(gad, GadPosX, GadPosY)
            fail+=GetSelRow(gad, GadPosX, GadPosY)
            if fail=0 then
              row=gad->xtd.dtd.RowList->GetAddr(gad->xtd.dtd.SelectedRowID, gad->xtd.dtd.VPLower_Row)
              gad->xtd.dtd.SelectedCell=row->GetAddr(gad->xtd.dtd.SelectedColumnID)
            end if
        end select
      else
        fail +=1
      end if

      if fail then 
        gad->xtd.dtd.SelectionMode=0
        gad->xtd.dtd.SelectedRowID=0
        'gad->xtd.dtd.SelectedRow=0        
        gad->xtd.dtd.SelectedColumnID=0
        'gad->xtd.dtd.SelectedColumn=0        
        gad->xtd.dtd.SelectedCell=0
        
      end if
      
      gad->ReDraw=1       
      function=1
    
    case GADGET_LMBHOLDOFF,GADGET_LMBRELEASEOFF

    case GADGET_MOUSEHOVER
      gad->MouseHover=1
    
    case GADGET_MOUSENEXT
      gad->MouseHover=0
  end select
end function


sub DTD_Draw (gad as Gadget ptr)
	dim as FB.Image ptr buffer
  dim as sGUIDGColumn ptr cinfo
  dim as sGUIDGCell ptr cell
  dim as sGUIList ptr row
  dim as integer ColumnPos,RowPos
  dim as integer cellheight,counter,csel
  dim as ulong col,tcol
  
  cellheight=gad->xtd.dtd.CellHeight
	Buffer=gad->DrawBuffer->img
  
'OFF
  ClearBox Buffer,0,0,gad->GadWidth,gad->GadHeight,Colors.DGR_DataBackGround
'ON
  'Hauptbedingung fr den "Rest", es mssen Spalten da sein
  if gad->xtd.dtd.ColumnList->NumNodes then  
    
    'ClearBox    Buffer,gad->xtd.dtd.InfoPosX + ColumnPos,gad->xtd.dtd.InfoPosY,gad->xtd.dtd.InfoWidth,gad->xtd.dtd.InfoHeight,Colors.DGR_InfoBackground                  
    GrdFrame    Buffer,gad->xtd.dtd.InfoPosX + ColumnPos,gad->xtd.dtd.InfoPosY,gad->xtd.dtd.InfoWidth,gad->xtd.dtd.InfoHeight  
    
    'Column ******************************
    cinfo=gad->xtd.dtd.VPLower_Column
    ColumnPos=0
    do
      col=iif(cinfo->Index=gad->xtd.dtd.SelectedColumnID,Colors.DGR_InfoBackGroundSelected,Colors.DGR_InfoBackGround)
      tcol=iif(cinfo->Index=gad->xtd.dtd.SelectedColumnID,Colors.DGR_TextSelected,Colors.DGR_Text)
      ClearBox    Buffer,gad->xtd.dtd.GrdPosX + ColumnPos,gad->xtd.dtd.InfoPosY,cinfo->ColumnWidth,cellheight,col             
      drawstring  Buffer,gad->xtd.dtd.GrdPosX + ColumnPos+sGUIMainGap,gad->xtd.dtd.InfoPosY+sGUIMainGap,cinfo->Text,tcol,2     
      GrdFrame    Buffer,gad->xtd.dtd.GrdPosX + ColumnPos,gad->xtd.dtd.InfoPosY,cinfo->ColumnWidth,cellheight        
      ColumnPos += cinfo->ColumnWidth
      cinfo=cast(sGUIDGColumn ptr,cinfo->next_node) 
    loop until (cinfo=0) or (ColumnPos>=gad->xtd.dtd.GrdWidth)

    'Counter ******************************
    if gad->xtd.dtd.RowList->NumNodes then
      RowPos=0
      counter=gad->xtd.dtd.VPLower_RowID
      do
        col=iif(counter=gad->xtd.dtd.SelectedRowID,Colors.DGR_InfoBackGroundSelected,Colors.DGR_InfoBackGround)
        tcol=iif(counter=gad->xtd.dtd.SelectedRowID,Colors.DGR_TextSelected,Colors.DGR_Text)      
        ClearBox    Buffer,gad->xtd.dtd.InfoPosX,gad->xtd.dtd.GrdPosY + RowPos,gad->xtd.dtd.InfoWidth,cellheight,col
        drawstring  Buffer,gad->xtd.dtd.InfoPosX +sGUIMainGap,gad->xtd.dtd.GrdPosY + RowPos +sGUIMainGap,str(counter),tcol,2   
        GrdFrame    Buffer,gad->xtd.dtd.InfoPosX,gad->xtd.dtd.GrdPosY + RowPos,gad->xtd.dtd.InfoWidth,cellheight 
        RowPos +=gad->xtd.dtd.CellHeight
        counter +=1
      loop until (RowPos>=gad->xtd.dtd.GrdHeight) or (counter > gad->xtd.dtd.RowList->NumNodes)
   
    'Cells *********************************
      row=gad->xtd.dtd.VPLower_Row
      RowPos=0
      do
        cell=row->GetAddr(gad->xtd.dtd.VPLower_ColumnID)
        cinfo=gad->xtd.dtd.VPLower_Column       
        ColumnPos=0        
        do
        
          select case gad->xtd.dtd.SelectionMode
            case 0
              col=Colors.DGR_DataBackGround
              'tcol=Colors.DGR_Text                        
            case 1
              col=iif(cinfo->Index=gad->xtd.dtd.SelectedColumnID,Colors.DGR_DataBackGroundSelected,Colors.DGR_DataBackGround) 
              'tcol=iif(cinfo->Index=gad->xtd.dtd.SelectedColumnID,Colors.DGR_TextSelected,Colors.DGR_Text)
            case 2
              col=iif(row->Index=gad->xtd.dtd.SelectedRowID,Colors.DGR_DataBackGroundSelected,Colors.DGR_DataBackGround)
              'tcol=iif(row->Index=gad->xtd.dtd.SelectedRowID,Colors.DGR_TextSelected,Colors.DGR_Text)
            case 4
              col=iif(cell=gad->xtd.dtd.SelectedCell,Colors.DGR_DataBackGroundSelected,Colors.DGR_DataBackGround)
              'tcol=iif(cell=gad->xtd.dtd.SelectedCell,Colors.DGR_TextSelected,Colors.DGR_Text)
          end select        
        
          ClearBox    Buffer,gad->xtd.dtd.GrdPosX + ColumnPos,gad->xtd.dtd.GrdPosY + RowPos,cinfo->ColumnWidth,cellheight,col
          drawstring  Buffer,gad->xtd.dtd.GrdPosX + ColumnPos+sGUIMainGap,gad->xtd.dtd.GrdPosY + RowPos+sGUIMainGap,cell->Text,Colors.DGR_Text,2              
          GrdFrame    Buffer,gad->xtd.dtd.GrdPosX + ColumnPos,gad->xtd.dtd.GrdPosY + RowPos,cinfo->ColumnWidth,cellheight         

          ColumnPos += cinfo->ColumnWidth
          cell=cast(sGUIDGCell ptr,cell->next_node)
          cinfo=cast(sGUIDGColumn ptr,cinfo->next_node)           
        loop until (cell=0) or (cinfo=0) or (ColumnPos>=gad->xtd.dtd.GrdWidth)
        
        RowPos +=gad->xtd.dtd.CellHeight
        row=cast(sGUIList ptr,row->next_node)
      loop until (row=0) or (RowPos>=gad->xtd.dtd.GrdHeight)'gibt es keine oder ist die nchste untere Zelle ausserhalb, Abbruch!!!    
    end if
    
    'Rechter Rand Reinigung
    if ColumnPos<gad->xtd.dtd.GrdWidth then'falls dargestellte Spalten kleiner als der "Datenviewport" sind und noch lange Textreste zu sehen sind
      ClearBox    Buffer,gad->xtd.dtd.GrdPosX + ColumnPos,1,gad->xtd.dtd.GrdWidth - ColumnPos,gad->GadHeight-1,Colors.DGR_DataBackGround    
    end if
  end if    
  
  StdFrame Buffer,0,0,gad->GadWidth,gad->GadHeight,Colors.DGR_DataBackGround,Colors.DGR_DataBackGround,0
'SLEEP
    if gad->Activation=2 then Raster Buffer,0,0,gad->GadWidth,gad->GadHeight
end sub


sub SetLayout (gad as Gadget ptr)
  if gad->xtd.dtd.ColumnList->NumNodes>0 then    
    gad->xtd.dtd.InfoWidth=GetTextWidth(str(gad->xtd.dtd.RowList->NumNodes), 2) + 2*sGUIMainGap
    gad->xtd.dtd.GrdPosX=gad->xtd.dtd.InfoPosX + gad->xtd.dtd.InfoWidth 
    gad->xtd.dtd.GrdWidth=gad->GadWidth - gad->xtd.dtd.GrdPosX - 1
  else 
    gad->xtd.dtd.InfoWidth=GetTextWidth(str(gad->xtd.dtd.VPNumRows), 2) + 2*sGUIMainGap
    gad->xtd.dtd.GrdPosX=gad->xtd.dtd.InfoPosX + gad->xtd.dtd.InfoWidth
    gad->xtd.dtd.GrdWidth=gad->GadWidth - gad->xtd.dtd.GrdPosX - 1
  end if 
end sub


sub SetScrollLimitsColumn (gad as Gadget ptr)
  dim as sGUIDGColumn ptr cinfo
  dim as integer WidthCumulative,found

  if gad->xtd.dtd.ColumnList->NumNodes then
  
    '1. linker Scrollrand Suchrichtung left->right
    gad->xtd.dtd.MinLower_Column    = gad->xtd.dtd.ColumnList->GetFirst
    gad->xtd.dtd.MinLower_ColumnID  = gad->xtd.dtd.MinLower_Column->Index  
    cinfo=gad->xtd.dtd.MinLower_Column
    WidthCumulative=0
    found=0
    do          
      WidthCumulative +=cinfo->ColumnWidth
      gad->xtd.dtd.MinHigher_ColumnID=cinfo->Index
      gad->xtd.dtd.MinHigher_Column=cinfo   
      cinfo=cast(sGUIDGColumn ptr,cinfo->next_node)'vorwrts
      if cinfo then
        if (WidthCumulative + cinfo->ColumnWidth) > gad->xtd.dtd.GrdWidth then found=1
      end if
    loop until (cinfo=0) or (found=1)'falls keine gefunden oder Listenende erreicht
    gad->xtd.dtd.MinNumColumns=gad->xtd.dtd.MinHigher_ColumnID - gad->xtd.dtd.MinLower_ColumnID + 1  
    
    '2. rechter Scrollrand Suchrichtung right->left
    gad->xtd.dtd.MaxHigher_Column    = gad->xtd.dtd.ColumnList->GetLast
    gad->xtd.dtd.MaxHigher_ColumnID  = gad->xtd.dtd.MaxHigher_Column->Index   
    cinfo=gad->xtd.dtd.MaxHigher_Column
    WidthCumulative=0
    found=0
    do          
      WidthCumulative +=cinfo->ColumnWidth
      gad->xtd.dtd.MaxLower_ColumnID=cinfo->Index
      gad->xtd.dtd.MaxLower_Column=cinfo
      cinfo=cast(sGUIDGColumn ptr,cinfo->prev_node)'rckwrts
      if cinfo then
        if (WidthCumulative + cinfo->ColumnWidth) > gad->xtd.dtd.GrdWidth then found=1
      end if
    loop until (cinfo=0) or (found=1)'falls keine gefunden oder Listenende erreicht  
    gad->xtd.dtd.MaxNumColumns=gad->xtd.dtd.MaxHigher_ColumnID - gad->xtd.dtd.MaxLower_ColumnID + 1
    
  else
    
    gad->xtd.dtd.MinLower_Column    =0
    gad->xtd.dtd.MinLower_ColumnID  =0  
    gad->xtd.dtd.MinHigher_Column   =0
    gad->xtd.dtd.MinHigher_ColumnID =0
    gad->xtd.dtd.MinNumColumns      =0  
    gad->xtd.dtd.MaxLower_Column    =0
    gad->xtd.dtd.MaxLower_ColumnID  =0       
    gad->xtd.dtd.MaxHigher_Column   =0
    gad->xtd.dtd.MaxHigher_ColumnID =0
    gad->xtd.dtd.MaxNumColumns      =0
    
  end if
end sub


sub SetScrollLimitsRow (gad as Gadget ptr)
  dim as sGUIList ptr row
  dim as integer HeightCumulative,found,gHeight
  gHeight=gad->xtd.dtd.GrdHeight - gad->xtd.dtd.CellHeight
  
  if gad->xtd.dtd.RowList->NumNodes then
  
    '1. oberer Scrollrand Suchrichtung oben->unten
    gad->xtd.dtd.MinLower_Row    = gad->xtd.dtd.RowList->GetFirst
    gad->xtd.dtd.MinLower_RowID  = gad->xtd.dtd.MinLower_Row->Index  
    row=gad->xtd.dtd.MinLower_Row
    HeightCumulative=0
    found=0
    do          
      HeightCumulative +=gad->xtd.dtd.CellHeight
      gad->xtd.dtd.MinHigher_RowID=row->Index
      gad->xtd.dtd.MinHigher_Row=row   
      row=cast(sGUIList ptr,row->next_node)'vorwrts
      if row then
        if (HeightCumulative + gad->xtd.dtd.CellHeight) > gHeight then found=1
      end if
    loop until (row=0) or (found=1)'falls keine gefunden oder Listenende erreicht
    gad->xtd.dtd.MinNumRows=gad->xtd.dtd.MinHigher_RowID - gad->xtd.dtd.MinLower_RowID + 1  
    
    '2. rechter Scrollrand Suchrichtung right->left
    gad->xtd.dtd.MaxHigher_Row    = gad->xtd.dtd.RowList->GetLast
    gad->xtd.dtd.MaxHigher_RowID  = gad->xtd.dtd.MaxHigher_Row->Index   
    row=gad->xtd.dtd.MaxHigher_Row
    HeightCumulative=0
    found=0
    do          
      HeightCumulative +=gad->xtd.dtd.CellHeight
      gad->xtd.dtd.MaxLower_RowID=row->Index
      gad->xtd.dtd.MaxLower_Row=row
      row=cast(sGUIList ptr,row->prev_node)'rckwrts
      if row then
        if (HeightCumulative + gad->xtd.dtd.CellHeight) > gHeight then found=1
      end if
    loop until (row=0) or (found=1)'falls keine gefunden oder Listenende erreicht  
    gad->xtd.dtd.MaxNumRows=gad->xtd.dtd.MaxHigher_RowID - gad->xtd.dtd.MaxLower_RowID + 1
  
  else
    
    gad->xtd.dtd.MinLower_Row     =0
    gad->xtd.dtd.MinLower_RowID   =0  
    gad->xtd.dtd.MinHigher_Row    =0
    gad->xtd.dtd.MinHigher_RowID  =0
    gad->xtd.dtd.MinNumRows       =0  
    gad->xtd.dtd.MaxLower_Row     =0
    gad->xtd.dtd.MaxLower_RowID   =0       
    gad->xtd.dtd.MaxHigher_Row    =0
    gad->xtd.dtd.MaxHigher_RowID  =0
    gad->xtd.dtd.MaxNumRows       =0
    
  end if
end sub


sub SetViewPortColumn(gad as Gadget ptr, target as integer=0)  
  dim as sGUIDGColumn ptr cinfo
  dim as integer WidthCumulative,found,tcase 
  
  if gad->xtd.dtd.ColumnList->NumNodes then
    
    'wenn keine Ziel, dann ist Ziel die selektierte Spalte
    if target=0 then target=gad->xtd.dtd.SelectedColumnID

    if target<gad->xtd.dtd.MinLower_ColumnID then target=gad->xtd.dtd.MinLower_ColumnID
    if target>gad->xtd.dtd.MaxHigher_ColumnID then target=gad->xtd.dtd.MaxHigher_ColumnID  
    
    if (target<=gad->xtd.dtd.VPLower_ColumnID) then tcase=1
    if (target>=gad->xtd.dtd.VPHigher_ColumnID) then tcase=2

    select case tcase
      case 1
        gad->xtd.dtd.VPLower_ColumnID  = target
        gad->xtd.dtd.VPLower_Column    = gad->xtd.dtd.ColumnList->GetAddr(gad->xtd.dtd.VPLower_ColumnID)', gad->xtd.dtd.VPLower_Column)
        cinfo=gad->xtd.dtd.VPLower_Column
        WidthCumulative=0
        found=0
        do          
          WidthCumulative +=cinfo->ColumnWidth
          gad->xtd.dtd.VPHigher_ColumnID=cinfo->Index
          gad->xtd.dtd.VPHigher_Column=cinfo     
          cinfo=cast(sGUIDGColumn ptr,cinfo->next_node)'vorwrts
          if cinfo then
            if (WidthCumulative + cinfo->ColumnWidth) > gad->xtd.dtd.GrdWidth then found=1
          end if
        loop until (cinfo=0) or (found=1)'falls keine gefunden oder Listenende erreicht 
      
      case 2
        gad->xtd.dtd.VPHigher_ColumnID  = target
        gad->xtd.dtd.VPHigher_Column    = gad->xtd.dtd.ColumnList->GetAddr(gad->xtd.dtd.VPHigher_ColumnID)', gad->xtd.dtd.VPHigher_Column)
        cinfo=gad->xtd.dtd.VPHigher_Column
        WidthCumulative=0
        found=0
        do          
          WidthCumulative +=cinfo->ColumnWidth
          gad->xtd.dtd.VPLower_ColumnID=cinfo->Index
          gad->xtd.dtd.VPLower_Column=cinfo
          cinfo=cast(sGUIDGColumn ptr,cinfo->prev_node)'rckwrts
          if cinfo then
            if (WidthCumulative + cinfo->ColumnWidth) > gad->xtd.dtd.GrdWidth then found=1
          end if
        loop until (cinfo=0) or (found=1)'falls keine gefunden oder Listenende erreicht         
      
    end select
   
    gad->xtd.dtd.VPNumColumns=gad->xtd.dtd.VPHigher_ColumnID - gad->xtd.dtd.VPLower_ColumnID + 1    
  
  else
  
    gad->xtd.dtd.VPLower_Column   =0
    gad->xtd.dtd.VPLower_ColumnID =0            
    gad->xtd.dtd.VPHigher_Column  =0
    gad->xtd.dtd.VPHigher_ColumnID=0
    gad->xtd.dtd.VPNumColumns     =0
  
  end if
end sub


sub SetViewPortRow(gad as Gadget ptr, target as integer=0)  
  dim as sGUIList ptr row
  dim as integer HeightCumulative,found,tcase  
  
  if gad->xtd.dtd.RowList->NumNodes then
  
    'wenn keine Ziel, dann ist Ziel die selektierte Spalte
    if target=0 then target=gad->xtd.dtd.SelectedRowID 
    
    if target<gad->xtd.dtd.MinLower_RowID then target=gad->xtd.dtd.MinLower_RowID
    if target>gad->xtd.dtd.MaxHigher_RowID then target=gad->xtd.dtd.MaxHigher_RowID      
    
    if (target<=gad->xtd.dtd.VPLower_RowID) then tcase=1
    if (target>=gad->xtd.dtd.VPHigher_RowID) then tcase=2
    
    select case tcase
      case 1
        gad->xtd.dtd.VPLower_RowID  = target
        gad->xtd.dtd.VPLower_Row    = gad->xtd.dtd.RowList->GetAddr(gad->xtd.dtd.VPLower_RowID)', gad->xtd.dtd.VPLower_Row)
        row=gad->xtd.dtd.VPLower_Row
        HeightCumulative=0
        found=0
        do          
          HeightCumulative +=gad->xtd.dtd.CellHeight
          gad->xtd.dtd.VPHigher_RowID=row->Index
          gad->xtd.dtd.VPHigher_Row=row     
          row=cast(sGUIList ptr,row->next_node)'vorwrts
          if row then
            if (HeightCumulative + gad->xtd.dtd.CellHeight) > gad->xtd.dtd.GrdHeight then found=1
          end if
        loop until (row=0) or (found=1)'falls keine gefunden oder Listenende erreicht 
  
      case 2
        gad->xtd.dtd.VPHigher_RowID  = target
        gad->xtd.dtd.VPHigher_Row    = gad->xtd.dtd.RowList->GetAddr(gad->xtd.dtd.VPHigher_RowID)', gad->xtd.dtd.VPHigher_Row)
        row=gad->xtd.dtd.VPHigher_Row
        HeightCumulative=0
        found=0
        do          
          HeightCumulative +=gad->xtd.dtd.CellHeight
          gad->xtd.dtd.VPLower_RowID=row->Index
          gad->xtd.dtd.VPLower_Row=row
          row=cast(sGUIList ptr,row->prev_node)'rckwrts
          if row then
            if (HeightCumulative + gad->xtd.dtd.CellHeight) > gad->xtd.dtd.GrdHeight then found=1
          end if
        loop until (row=0) or (found=1)'falls keine gefunden oder Listenende erreicht
        
    end select
   
    gad->xtd.dtd.VPNumRows=gad->xtd.dtd.VPHigher_RowID - gad->xtd.dtd.VPLower_RowID + 1

  else
  
    gad->xtd.dtd.VPLower_Row          =0
    gad->xtd.dtd.VPLower_RowID        =0        
    gad->xtd.dtd.VPHigher_Row         =0
    gad->xtd.dtd.VPHigher_RowID       =0
    gad->xtd.dtd.VPNumRows            =0
  
  end if
  
end sub


sub CreateColumn(gad as Gadget ptr, cname as string, cwidth as integer=80)
  dim as sGUIList ptr row
  dim as sGUIDGColumn ptr cinfo  
  cinfo=gad->xtd.dtd.ColumnList->AppendNew(sGUIDGColumnType)  
  cinfo->Text=cname
  cinfo->ColumnWidth=cwidth

  if gad->xtd.dtd.RowList->NumNodes then'wenn Zeilen existieren dann jeder Zeile eine Zelle(Spalte) hinzufgen 
    row=gad->xtd.dtd.RowList->GetFirst
    do
      row->AppendNew(sGUIDGCellType)
      row=cast(sGUIList ptr,row->next_node)
    loop until row=0
  end if
  gad->ReDraw=1
end sub


sub CreateRow(gad as Gadget ptr,num as integer=1)
  dim as sGUIList ptr row
  dim as sGUIDGColumn ptr cinfo 
  if gad->xtd.dtd.ColumnList->NumNodes>0 then'nur wenn Spalten(-definitionen) in ColumnList existieren, knnen auch Zeilen erzeugt werden
    for i as integer=1 to num
      row=gad->xtd.dtd.RowList->AppendNew(sGUIListType)
      if row then
        for k as integer=1 to gad->xtd.dtd.ColumnList->NumNodes'soviel Zellen hinzufgen, wie es Spalten gibt
          row->AppendNew(sGUIDGCellType)
        next k
      end if
    next i
  end if
  gad->ReDraw=1
end sub


function GetSelColumn(gad as Gadget ptr, GadPosX as integer, GadPosY as integer) as integer
  function=0
  dim as sGUIList ptr column
  dim as sGUIDGColumn ptr cinfo    
  dim as integer found,ColumnPosCumulative
  found=0
  
  if gad->xtd.dtd.ColumnList->NumNodes then
    cinfo=gad->xtd.dtd.VPLower_Column
    ColumnPosCumulative=GadPosX + gad->xtd.dtd.GrdPosX         
    do
      if (MOUSEX>=ColumnPosCumulative) and (MOUSEX<(ColumnPosCumulative + cinfo->ColumnWidth)) then
        gad->xtd.dtd.SelectedColumnID=cinfo->Index
        gad->xtd.dtd.SelectedColumn=cinfo
        gad->xtd.dtd.EditPosXGlobal=ColumnPosCumulative
        found=1
      end if
      ColumnPosCumulative +=cinfo->ColumnWidth
      cinfo=cast(sGUIDGColumn ptr,cinfo->next_node)'Spaltenwechsel
    loop until (cinfo=0) or (found=1)          
  end if
  if found=0 then function=1  
end function


function GetSelRow(gad as Gadget ptr, GadPosX as integer, GadPosY as integer) as integer
  function=0
  gad->xtd.dtd.SelectedRowID=int((MOUSEY - (GadPosY + gad->xtd.dtd.InfoPosY))/gad->xtd.dtd.CellHeight) + gad->xtd.dtd.VPLower_RowID - 1   
  gad->xtd.dtd.SelectedRow=GetRowAddr(gad,gad->xtd.dtd.SelectedRowID)
  if gad->xtd.dtd.SelectedRowID > gad->xtd.dtd.RowList->NumNodes then 
    function=1
  else
    gad->xtd.dtd.EditPosYGlobal =GadPosY + 1 + int((MOUSEY-GadPosY-1)/gad->xtd.dtd.CellHeight)*gad->xtd.dtd.CellHeight
  end if
end function


function GetRowAddr(gad as Gadget ptr, rowid as integer) as _sGUIList ptr
  if (rowid>0) and (rowid<=gad->xtd.dtd.RowList->NumNodes) then
    function=gad->xtd.dtd.RowList->GetAddr(rowid,gad->xtd.dtd.VPLower_Row)
  else
    function=0
  end if
end function 


function GetCellAddr(gad as Gadget ptr, rowid as integer, columnid as integer) as _sGUIDGCell ptr
  dim as sGUIDGCell ptr cell
  dim as _sGUIList ptr row
  cell=0
  row=GetRowAddr(gad,rowid)
  if row then
    if (columnid>0) and (columnid<=gad->xtd.dtd.ColumnList->NumNodes) then
      cell=row->GetAddr(columnid)
    else
      cell=0
    end if
  end if
  function=cell
end function 
  
end namespace

