'Color Stuff
declare function ColorSelection (BodyColor as ulong, BodySelectColor as ulong, selected as integer ,hover as integer,hovermode as integer=0) as ulong
declare function EntryColorSelection ( selected as integer ,hover as integer) as ulong
declare sub CalcPale(ciBase as ColorInfo, Intensity as integer,byref ciDest as ColorInfo)
declare sub CalcDark(ciBase as ColorInfo, Intensity as integer,byref ciDest as ColorInfo)
declare sub CalcShiny(ciBase as ColorInfo, Intensity as integer,byref ciDest as ColorInfo)
'Fill Basics
declare sub ClearBox (img as FB.Image ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,col as ulong=Colors.Cleaning)
declare sub Raster (img as FB.Image ptr, PosX as integer, PosY as integer, BoxWidth as integer, BoxHeight as integer, col as ulong=Colors.GadSleepPattern, mode as integer=1)
declare sub GradientFXBox(img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer, _
                    ColorTopLeft as ulong,ColorTopRight as ulong,ColorBottomLeft as ulong,ColorBottomRight as ulong)
'Fills
declare sub StdFill (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub AltFillA (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)

'Frames
declare sub GetFrameColor( b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0, byref ci as ColorInfo)
declare sub StdFrame (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0, switch as integer=-1)
declare sub GrdFrame (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer)

declare sub WinFrame (img as FB.Image ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,selected as integer=0)
declare sub WinShadow (img as FB.Image ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer)

'Boxes
declare sub StdFilledBox (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub FilledBoxKnob (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub FilledBoxContainer (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub FilledBoxDrop (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0,mode as integer=0)
declare sub FilledBoxList (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub FilledBoxEntry (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,selected as integer=0,hover as integer=0)
declare sub FilledBoxRadio (img as FB.Image ptr, PosX as integer,PosY as integer,BoxSize as integer,Radius as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
declare sub FilledBoxCheckMark (img as FB.Image ptr, PosX as integer,PosY as integer,BoxSize as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
'Symbols
declare sub DrawMenuRBDot (img as FB.Image ptr, PosX as integer,PosY as integer, Radius as integer, col as ulong)
declare sub Symbol_Arrow (img as FB.Image ptr, PosX as integer,PosY as integer,size as integer,direction as integer,col as ulong,thickness as integer=2)

declare sub Symbol_CheckMark (img as FB.Image ptr, PosX as integer,PosY as integer,size as integer,col as ulong=Colors.Black)
declare sub Symbol_X (img as FB.Image ptr, PosX as integer,PosY as integer, col as ulong=Colors.Black)
declare sub Symbol_Cyclic (img as FB.Image ptr, PosX as integer,PosY as integer, col as ulong=Colors.Black)
declare sub DrawRBMask(img as FB.Image ptr, DrawSize as integer, Radius as integer)
declare sub DrawShadowMask (a as integer)

'******************************************************************************
'******************************************************************************
'******************************************************************************
'Color Stuff


function ColorSelection (BodyColor as ulong, BodySelectColor as ulong, selected as integer ,hover as integer,hovermode as integer=0) as ulong
  dim as ulong col
  if hover then
    
    select case hovermode
      case 0
        col=iif(selected=1,Colors.HoverFXSelected,Colors.HoverFX)
      case 1
        col=Colors.HoverFX
    end select
  
  else
    
    col=iif(selected=1,BodySelectColor,BodyColor) 
  
  end if
  
  function=col
end function


function EntryColorSelection ( selected as integer ,hover as integer) as ulong
  dim as ulong col
  if hover then
    col=iif(selected=1,Colors.LBX_BackGroundSelectedHoverFX,Colors.LBX_BackGroundHoverFX)
  else  
    col=iif(selected=1,Colors.LBX_BackGroundSelected,Colors.LBX_BackGround)  
  end if  
  function=col
end function


sub CalcPale(ciBase as ColorInfo, Intensity as integer,byref ciDest as ColorInfo)
  dim as single s,v

  s=ciBase.Saturation - ciBase.Saturation*(Intensity/101)
  v=ciBase.Value + (100-ciBase.Value)*(Intensity/101)
  SetHSV (ciDest, ciBase.Hue,s,v)
end sub



sub CalcDark(ciBase as ColorInfo, Intensity as integer,byref ciDest as ColorInfo)
  dim as single s,v

  if ciBase.Saturation>0 then s=ciBase.Saturation + (100-ciBase.Saturation)*(Intensity/101) else s=0'verhindert Rotstich
  v=ciBase.Value - ciBase.Value*Intensity/101
  SetHSV (ciDest, ciBase.Hue,s,v)
end sub



sub CalcShiny(ciBase as ColorInfo, Intensity as integer,byref ciDest as ColorInfo)
  dim as single s,v
  
  if ciBase.Saturation>0 then s=ciBase.Saturation + (100-ciBase.Saturation)*(Intensity/101) else s=0'verhindert Rotstich 
  v=ciBase.Value + (100-ciBase.Value)*(Intensity/101)
  SetHSV (ciDest, ciBase.Hue,s,v)
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
'Fill Basics


sub ClearBox (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,col as ulong=Colors.Cleaning)
  line img, (PosX,PosY)-(PosX+BoxWidth-1,PosY+BoxHeight-1),col,BF
end sub


sub Raster (img as FB.Image ptr, PosX as integer, PosY as integer, BoxWidth as integer, BoxHeight as integer, col as ulong=Colors.GadSleepPattern, mode as integer=1)
  select case mode
    case 1
      for k as integer=0 to BoxHeight-1 step 2
        for i as integer=0 to BoxWidth-1 step 4
          pset img,(PosX+i, PosY+k),col
          pset img,(PosX+i+1, PosY+k),col
          
          if ((k+1) <= (BoxHeight-1)) then
            if ((i+3) <= (BoxWidth-1)) then
              pset img,(PosX+i+2, PosY+k+1),col
              pset img,(PosX+i+3, PosY+k+1),col      
            end if
          end if
        next i
      next k

    case 2
      for k as integer=0 to BoxHeight-1 step 2
        for i as integer=0 to BoxWidth-1 step 2
          pset img,(PosX+i, PosY+k),col    
          if ( (i+1) <= (BoxWidth-1) ) and ( (k+1) <= (BoxHeight-1) ) then pset img,(PosX+i+1, PosY+k+1),col   
        next i
      next k

    case 3
      for k as integer=0 to BoxHeight-1 step 2
        line img,(PosX,PosY+k)-(PosX+Boxwidth-1,PosY+k),col    
      next k  
      
  end select
end sub


sub GradientFXFill(img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer, _
                    ColorTopLeft as ulong,ColorTopRight as ulong,ColorBottomLeft as ulong,ColorBottomRight as ulong)
  'Image/Screen Infos Pointer
  #if __FB_VERSION__ >= "1.08.0"
    #if defined (__fb_64bit__) 
      dim as ulong bpp,ptch,gcWidth,gcHeight                
    #else
      dim as integer bpp,ptch,gcWidth,gcHeight      
    #endif    
  #else
    dim as integer bpp,ptch
  #endif  
  dim as any ptr pdata
  dim as ulong ptr pxladdr    
  'Mathe und Farben
  dim as ulong cs,ce
  dim as integer bw,bh,gcPosX,gcPosY
  
  if img then
    imageinfo (img, gcWidth ,gcHeight , bpp, ptch, pdata)  
  else
    screeninfo ( gcWidth, gcHeight, , bpp, ptch) 
    pdata=screenptr
  end if
  'Berechnungen aus Schleife herausholen
  bw=BoxWidth-1
  bh=BoxHeight-1
  
  for y as integer=0 to bh
    cs=MixColor (ColorTopLeft, ColorBottomLeft, y/bh)
    ce=MixColor (ColorTopRight, ColorBottomRight, y/bh)   
    for x as integer=0 to bw
      'direkt in Screen/Image schreiben = bei mir etwa 45% schneller als die PSET Variante
      'erfordert eventuell screenlock/unlock
      gcPosX=PosX+x
      gcPosY=PosY+Y
      
      if (gcPosX>=0) and (gcPosX<gcWidth) and (gcPosY>=0) and (gcPosY<gcHeight) then
      
      pxladdr =pdata + gcPosY * ptch + gcPosX * bpp
      *pxladdr=MixColor (cs, ce, x/bw) 

      'ber PSET = langsamer
      'pset (PosX+x,PosY+y), MixColor (cs, ce, x/bw)
      end if
    next x
  next y
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
'Fills
sub StdFill (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  dim as ColorInfo fill,dark,shade,colorfx,lightfx
  dim as integer d1,d2,d3,bw,bh
  SetRGB(fill,  ColorSelection(b, s, selected,hover) )

  if GradientFX>0 then
    CalcDark(fill,GradientFX*.66,dark)
    CalcShiny(fill,GradientFX*.66,colorfx)    
    CalcDark(fill,GradientFX*.5,shade)
    CalcPale(fill,GradientFX*.5,lightfx)   
    if BoxWidth>=BoxHeight then  
      
      d1=BoxHeight*.5
      d2=BoxWidth*.5
      d3=BoxWidth-d2
      GradientFXFill img,PosX,PosY,d2,d1,lightfx.RGBValue,lightfx.RGBValue,dark.RGBValue,shade.RGBValue
      GradientFXFill img,PosX+d2,PosY,d3,d1,lightfx.RGBValue,dark.RGBValue,shade.RGBValue,dark.RGBValue
      GradientFXFill img,PosX,PosY+d1,d2,BoxHeight-d1,dark.RGBValue,shade.RGBValue,dark.RGBValue,colorfx.RGBValue
      GradientFXFill img,PosX+d2,PosY+d1,d3,BoxHeight-d1,shade.RGBValue,dark.RGBValue,colorfx.RGBValue,colorfx.RGBValue   
    else
      
      d1=BoxHeight*.5
      d2=BoxWidth*.5
      d3=BoxWidth-d2
      GradientFXFill img,PosX,PosY,d2,d1,lightfx.RGBValue,dark.RGBValue,lightfx.RGBValue,shade.RGBValue
      GradientFXFill img,PosX+d2,PosY,d3,d1,dark.RGBValue,dark.RGBValue,shade.RGBValue,colorfx.RGBValue
      GradientFXFill img,PosX,PosY+d1,d2,BoxHeight-d1,lightfx.RGBValue,shade.RGBValue,dark.RGBValue,dark.RGBValue
      GradientFXFill img,PosX+d2,PosY+d1,d3,BoxHeight-d1,shade.RGBValue,colorfx.RGBValue,dark.RGBValue,colorfx.RGBValue       
    
    
    end if

  else   
   
    ClearBox img,PosX,PosY,BoxWidth,BoxHeight,fill.RGBValue 
  end if
end sub


sub _StdFill (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  dim as ColorInfo fill,dark,shade,colorfx,lightfx
  dim as integer s1,s2
  SetRGB(fill,  ColorSelection(b, s, selected,hover) )

  if GradientFX>0 then
    CalcDark(fill,GradientFX,dark)
    CalcDark(fill,GradientFX*.66,shade)
    CalcPale(fill,GradientFX*.75,lightfx)   
    CalcShiny(fill,GradientFX*.86,colorfx)
    
    if BoxWidth>=BoxHeight then
      s1=BoxHeight*.5
      s2=BoxHeight-s1   
      GradientFXFill img,PosX,PosY,BoxWidth,s1,lightfx.RGBValue,dark.RGBValue,dark.RGBValue,dark.RGBValue
      GradientFXFill img,PosX,PosY+s1,BoxWidth,s2,dark.RGBValue,dark.RGBValue,shade.RGBValue,colorfx.RGBValue      
    else
      s1=BoxWidth*.5
      s2=BoxWidth-s1     
      GradientFXFill img,PosX,PosY,s1,BoxHeight,lightfx.RGBValue,dark.RGBValue,dark.RGBValue,dark.RGBValue
      GradientFXFill img,PosX+s1,PosY,s2,BoxHeight,dark.RGBValue,shade.RGBValue,dark.RGBValue,colorfx.RGBValue      
    end if
  
  else   
   
    ClearBox img,PosX,PosY,BoxWidth,BoxHeight,fill.RGBValue 
  end if
end sub


sub AltFillA (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  dim as ColorInfo fill,dark,shade,colorfx,lightfx

  SetRGB(fill,  ColorSelection(b, s, selected,hover) )

  if GradientFX>0 then
    CalcDark(fill,GradientFX*.33,dark)
    CalcDark(fill,GradientFX*.25,shade)       
    CalcPale(fill,GradientFX*.33,lightfx)

    
    
    if BoxWidth>=BoxHeight then   
      GradientFXFill img,PosX,PosY,BoxWidth,BoxHeight,dark.RGBValue,dark.RGBValue,shade.RGBValue,lightfx.RGBValue   
    else    
      GradientFXFill img,PosX,PosY,BoxWidth,BoxHeight,dark.RGBValue,shade.RGBValue,dark.RGBValue,lightfx.RGBValue     
    end if
  
  else   
   
    ClearBox img,PosX,PosY,BoxWidth,BoxHeight,fill.RGBValue 
  end if
end sub



'******************************************************************************
'******************************************************************************
'******************************************************************************
'Frames


sub GetFrameColor( b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0, byref ci as ColorInfo)
  dim as ColorInfo c
  SetRGB(c, ColorSelection(b, s, selected,hover)) 
  
  if FrameContrastFX<0 then
    CalcDark(c,FrameContrastFX*-1,ci)'->Abdunkeln, letztlich Schwarz
  else
    CalcPale(c,FrameContrastFX,ci)'->Aufhellung, letztlich Weiss      
  end if
end sub


sub StdFrame (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0, switch as integer=-1)
  dim as ColorInfo frame,pale,dark,gap
  GetFrameColor(b,s,selected,hover,frame)
  if switch>-1 then selected=switch
  
  CalcPale(frame, BevelFX, pale)
  CalcDark(frame, BevelFX, dark)
  CalcDark(frame, 100, gap)  
  
  if selected then     
    line img, (PosX,PosY+BoxHeight-1)-(PosX,PosY),dark.RGBValue'links
    line img, -(PosX+BoxWidth-1,PosY),dark.RGBValue'oben
    line img, -(PosX+BoxWidth-1,PosY+BoxHeight-1),pale.RGBValue'rechts     
    line img, -(PosX+1,PosY+BoxHeight-1),pale.RGBValue'unten        
  else
    line img, (PosX,PosY+BoxHeight-1)-(PosX,PosY),pale.RGBValue'links
    line img, -(PosX+BoxWidth-1,PosY),pale.RGBValue'oben
    line img, -(PosX+BoxWidth-1,PosY+BoxHeight-1),dark.RGBValue'rechts     
    line img, -(PosX+1,PosY+BoxHeight-1),dark.RGBValue'unten  
  end if  
end sub


sub GrdFrame (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer)
   line img, (PosX,PosY+BoxHeight-1)	-(PosX+BoxWidth-1,PosY+BoxHeight-1),Colors.DGR_Frame
   line img, (PosX+BoxWidth-1,PosY)	-(PosX+BoxWidth-1,PosY+BoxHeight-1),Colors.DGR_Frame      
end sub


sub WinFrame (img as FB.Image ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,selected as integer=0)
  dim as ColorInfo fill,dark,shade,colorfx,lightfx
  dim as ulong col
  SetRGB(fill, iif(selected=1,Colors.WinFrame,Colors.WinFrameUnselected)) 
  CalcDark(fill,GradientFX,dark)
  CalcDark(fill,GradientFX*.86,shade)
  CalcPale(fill,GradientFX*.86,lightfx)   
  CalcShiny(fill,GradientFX,colorfx)
  
  GradientFXFill img,0,0,BoxWidth,sGUIMainGap,lightfx.RGBValue,dark.RGBValue,lightfx.RGBValue,dark.RGBValue'oben horizontal
  GradientFXFill img,0,0,sGUIMainGap,BoxHeight,lightfx.RGBValue,lightfx.RGBValue,shade.RGBValue,shade.RGBValue'links vertikal
  GradientFXFill img,BoxWidth-sGUIMainGap,0,sGUIMainGap,BoxHeight,dark.RGBValue,dark.RGBValue,colorfx.RGBValue,colorfx.RGBValue'rechts vertikal    
  GradientFXFill img,0,BoxHeight-sGUIMainGap,BoxWidth,sGUIMainGap,shade.RGBValue,colorfx.RGBValue,shade.RGBValue,colorfx.RGBValue'unten horizontal
  
  if FrameFX then  
    StdFrame img,sGUIMainGap-1,sGUIMainGap-1,BoxWidth-2*sGUIMainGap+2,BoxHeight-2*sGUIMainGap+2,fill.RGBValue,fill.RGBValue,,,1'Innenrahmen  
    StdFrame img,0,0,BoxWidth,BoxHeight,fill.RGBValue,fill.RGBValue,,,0'Aussenrahmen
  end if
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
'Boxes


sub StdFilledBox (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0) 
  if FrameFX then
    StdFrame img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover  
    StdFill img,PosX+1,PosY+1,BoxWidth-2,BoxHeight-2,b,s,selected,hover
  else
    StdFill img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover  
  end if
end sub


'Knob Scrollbar
'bleibt immer "erhaben", lediglich "Farbspiel" bei Hover/Selection
sub FilledBoxKnob (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  if FrameFX then
    '#AltFillA img,PosX+1,PosY+1,BoxWidth-2,BoxHeight-2,b,s,selected,hover
    StdFill img,PosX+1,PosY+1,BoxWidth-2,BoxHeight-2,b,s,selected,hover
    StdFrame img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover,0  
  else
    'AltFillA img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover
    StdFill img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover
  end if
end sub


'Container Scrollbar
sub FilledBoxContainer (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  if FrameFX then 
    StdFrame img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover
    AltFillA img,PosX+1,PosY+1,BoxWidth-2,BoxHeight-2,b,s,selected,hover
  else
    AltFillA img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover
  end if
end sub


sub FilledBoxDrop (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0,mode as integer=0)
  dim as ulong symbolcolor
  dim as integer asize,a,o
  asize=int(sGUIMainSize*.7)
  a=(BoxWidth-asize)/2
  o=(BoxHeight-int(asize/2) ) /2  
  
  StdFill img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover  
 
  if hover then
    symbolcolor=iif(selected,Colors.HoverFXText,Colors.HoverFXText)
  else
    symbolcolor=Colors.GadText
  end if
  Symbol_Arrow (img,PosX+a,PosY+o,asize,3,symbolcolor)  
end sub


sub FilledBoxList (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
	dim as ColorInfo fill	
  SetRGB(fill, ColorSelection(b, s, selected,hover) )
  'StdFrame img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover
	'line img, (PosX+1,PosY+1)-(PosX+BoxWidth-2,PosY+BoxHeight-2),fill.RGBValue,BF
  if FrameFX then
    StdFrame img,PosX,PosY,BoxWidth,BoxHeight,b,s,selected,hover
    line img, (PosX+1,PosY+1)-(PosX+BoxWidth-2,PosY+BoxHeight-2),fill.RGBValue,BF  
  else
    line img, (PosX,PosY)-(PosX+BoxWidth,PosY+BoxHeight),fill.RGBValue,BF  
  end if  
end sub


sub FilledBoxEntry (img as FB.Image ptr, PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer,selected as integer=0,hover as integer=0)
	dim as ColorInfo fill	
  SetRGB(fill, EntryColorSelection (selected,hover))
  line img, (PosX,PosY)-(PosX+BoxWidth-1,PosY+BoxHeight-1),fill.RGBValue,BF
end sub


sub FilledBoxRadio (img as FB.Image ptr, PosX as integer,PosY as integer,BoxSize as integer,Radius as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  dim as ColorInfo framecolor,lightFX,dark
  dim as ulong dotcolor
  dim as integer px,py,x,y,res
  dim as single pi,quarterpi

  quarterpi =atn (1)
  pi        =quarterpi * 4  
  res=8
  px=PosX+Radius
  py=PosY+Radius
  StdFill img,PosX,PosY,BoxSize,BoxSize,b,s,selected,hover
  put img,(PosX,PosY),cast(FB.Image ptr,RadioButtonMask->img),trans
  GetFrameColor(b,s,selected,hover,framecolor)
  
  if FrameFX then  
    if BevelFX then 	      
      CalcPale(framecolor, BevelFX, lightFX)
      CalcDark(framecolor, BevelFX, dark)  
    else 
      SetRGB(lightFX, framecolor.RGBValue) 
      SetRGB(dark, framecolor.RGBValue)    
    end if  
    
    
    for i as integer=0 to res
      x=fix(cos(quarterpi + pi * i/res) * Radius)
      y=fix(sin(quarterpi + pi * i/res) * Radius)
      if i=0 then
        pset img,(px+x, py-y), dark.RGBValue
      else
        line img, - (px+x, py-y), dark.RGBValue
      end if
    next i
    for i as integer=0 to res
      x=fix(cos(pi + quarterpi + pi * i/res) * Radius)
      y=fix(sin(pi + quarterpi + pi * i/res) * Radius)
      if i=0 then
        pset img,(px+x, py-y), lightFX.RGBValue
      else
        line img, - (px+x, py-y),lightFX.RGBValue
      end if
    next    
  else

  end if
  
  if selected then 
    if hover then
      dotcolor=iif(selected,Colors.HoverFXText,Colors.HoverFXText)
    else
      dotcolor=Colors.GadText
    end if 
    'circle img, (PosX+Radius,PosY+Radius), Radius/2, dotcolor,,,,F
    DrawMenuRBDot img, PosX+Radius, PosY+Radius, Radius/2, dotcolor
  end if
end sub


sub FilledBoxCheckMark (img as FB.Image ptr, PosX as integer,PosY as integer,BoxSize as integer,b as ulong=Colors.GadBody,s as ulong=Colors.GadBodySelected,selected as integer=0,hover as integer=0)
  dim as ulong cmcolor
  dim as integer ssize,a,o
  ssize=BoxSize*.6
  a=(sGUIMainSize-ssize)/2

  if FrameFX then
    'AltFillB img,PosX+1,PosY+1,BoxSize-2,BoxSize-2,b,s,selected,hover
    StdFill img,PosX+1,PosY+1,BoxSize-2,BoxSize-2,b,s,selected,hover
    StdFrame img,PosX,PosY,BoxSize,BoxSize,b,s,selected,hover,1	
  else
    'AltFillB img,PosX,PosY,BoxSize,BoxSize,b,s,selected,hover
    StdFill img,PosX,PosY,BoxSize,BoxSize,b,s,selected,hover
  end if

  if selected then 
    if hover then
      cmcolor=iif(selected,Colors.HoverFXText,Colors.HoverFXText)
    else
      cmcolor=Colors.GadText
    end if 
    Symbol_CheckMark (img, PosX+a,PosY+a,ssize,cmcolor)
  end if 	
end sub


'******************************************************************************
'******************************************************************************
'******************************************************************************
'Symbols

sub DrawMenuRBDot (img as FB.Image ptr, PosX as integer,PosY as integer, Radius as integer, col as ulong)
  dim as integer x,y,res
  dim as single pi,quarterpi
  quarterpi =atn (1)
  pi        =quarterpi * 4  
  res=8
  
  for i as integer=0 to res
    x=fix(cos(quarterpi + pi * i/res) * Radius)
    y=fix(sin(quarterpi + pi * i/res) * Radius)
    if i=0 then
      pset img,(PosX+x, PosY-y),col
    else
      line img, - (PosX+x, PosY-y),col
    end if
  next i
  for i as integer=0 to res
    x=fix(cos(pi + quarterpi + pi * i/res) * Radius)
    y=fix(sin(pi + quarterpi + pi * i/res) * Radius)
    if i=0 then
      pset img,(PosX+x, PosY-y),col
    else
      line img, - (PosX+x, PosY-y),col
    end if
  next i
  paint img,(PosX,PosY),col,col 
end sub


sub Symbol_Arrow (img as FB.Image ptr, PosX as integer,PosY as integer,size as integer,direction as integer,col as ulong,thickness as integer=2)
  dim as integer n,w 
  if size<8 then thickness=1
  
  w=size-1  
  if (size mod 2) then
    n=int(size/2)
  else
    n=size/2-1
  end if
  select case direction
    case 0'l
'line img, (PosX,PosY)-(PosX+n,PosY+w),&HFFFFFF,B
      for i as integer=0 to thickness
        line img, (PosX+n,PosY+i)-(PosX+i,PosY+n),col
        line img, (PosX+i,PosY+w-n)-(PosX+n,PosY+w-i),col
      next i
        
    case 1'r
'line img, (PosX,PosY)-(PosX+n,PosY+w),&HFFFFFF,B
      for i as integer=0 to thickness
        line img, (PosX,PosY+i)-(PosX+n-i,PosY+n),col
        line img, (PosX+n-i,PosY+w-n)-(PosX,PosY+w-i),col
      next i

    case 2'up
'line img, (PosX,PosY)-(PosX+w,PosY+n),&HFFFFFF,B
      for i as integer=0 to thickness
        line img, (PosX+i,PosY+n)-(PosX+n,PosY+i),col
        line img, (PosX+w-n,PosY+i)-(PosX+w-i,PosY+n),col
      next i
      
    case 3'dwn
'line img, (PosX,PosY)-(PosX+w,PosY+n),&HFFFFFF,B
      for i as integer=0 to thickness
        line img, (PosX+i,PosY)-(PosX+n,PosY+n-i),col
        line img, (PosX+w-n,PosY+n-i)-(PosX+w-i,PosY),col
      next i
  end select 
end sub


sub Symbol_CheckMark (img as FB.Image ptr, PosX as integer,PosY as integer,size as integer,col as ulong=Colors.Black)
  dim as integer n,w,thickness
  if size<16 then thickness=1 else thickness=2 
  w=size-1  
  if (size mod 2) then
    n=int(size/2)
  else
    n=size/2-1
  end if

  for i as integer=0 to thickness
    line img, (PosX+i,PosY+w-n)-(PosX+n,PosY+w-i),col
    line img, (PosX+n,PosY+w-i)-(PosX+w-i,PosY),col
  next i

end sub


sub Symbol_X (img as FB.Image ptr, PosX as integer,PosY as integer, col as ulong=Colors.Black)
  line img, (PosX+1,PosY+1)-(PosX+6,PosY+6),col
  line img, (PosX+1,PosY+0)-(PosX+7,PosY+6),col
	line img, (PosX+0,PosY+1)-(PosX+6,PosY+7),col
  
  line img, (PosX+1,PosY+6)-(PosX+6,PosY+1),col
  line img, (PosX+0,PosY+6)-(PosX+6,PosY+0),col
	line img, (PosX+1,PosY+7)-(PosX+7,PosY+1),col  
end sub


sub Symbol_Cyclic (img as FB.Image ptr, PosX as integer,PosY as integer, col as ulong=Colors.Black)
  line img, (PosX+0,PosY+2)-(PosX+1,PosY+8),col,BF
  line img, (PosX+7,PosY+2)-(PosX+8,PosY+6),col,BF  
  
  line img, (PosX+2,PosY+0)-(PosX+6,PosY+1),col,BF
	line img, (PosX+2,PosY+9)-(PosX+6,PosY+10),col,BF
  
  line img, (PosX+1,PosY+1)-(PosX+2,PosY+2),col
  line img, (PosX+1,PosY+9)-(PosX+2,PosY+8),col
  line img, (PosX+7,PosY+1)-(PosX+6,PosY+2),col
  'line img, (PosX+7,PosY+9)-(PosX+6,PosY+8),col
  
  'line img, (PosX+7,PosY+8)-(PosX+8,PosY+8),col

  line img, (PosX+5,PosY+4)-(PosX+6,PosY+4),col
  line img, (PosX+9,PosY+4)-(PosX+10,PosY+4),col
  
  pset img, (PosX+6,PosY+5),col
  pset img, (PosX+9,PosY+5),col  
end sub


sub DrawRBMask(img as FB.Image ptr, DrawSize as integer, Radius as integer)
  'dim as integer x,y,res
  'dim as single pi,quarterpi
  'quarterpi =atn (1)
  'pi        =quarterpi * 4  
  'res=8
 
  line img, (0,0)-(DrawSize-1,DrawSize-1),Colors.Background,BF  
  DrawMenuRBDot (img,Radius,Radius,Radius,&HFF00FF)   
  /'
  for i as integer=0 to res
    x=fix(cos(quarterpi + pi * i/res) * Radius)
    y=fix(sin(quarterpi + pi * i/res) * Radius)
    if i=0 then
      pset img,(Radius+x, Radius-y),&HFF00FF
    else
      line img, - (Radius+x, Radius-y),&HFF00FF
    end if
  next i
  for i as integer=0 to res
    x=fix(cos(pi + quarterpi + pi * i/res) * Radius)
    y=fix(sin(pi + quarterpi + pi * i/res) * Radius)
    if i=0 then
      pset img,(Radius+x, Radius-y),&HFF00FF
    else
      line img, - (Radius+x, Radius-y),&HFF00FF
    end if
  next i
  paint img,(Radius, Radius),&HFF00FF,&HFF00FF
  '/
end sub


sub DrawShadowMask (a as integer)
  dim as integer numrays
  dim as ulong alphavalue,maxalpha
  dim as single x,y,radian,radianstep
  maxalpha=255 * (a/100)'96
  numrays=(2*ShadowWidth * 3.1416)/3'Umfang/3 
  radianstep=1.57079/numrays'1.57079 -> Pi/2
  
  line ShadowCTL->Img,(0,0)-(ShadowWidth-1,ShadowWidth-1),&H00FFFFFF,BF
  line ShadowCTR->Img,(0,0)-(ShadowWidth-1,ShadowWidth-1),&H00FFFFFF,BF
  line ShadowCBL->Img,(0,0)-(ShadowWidth-1,ShadowWidth-1),&H00FFFFFF,BF
  line ShadowCBR->Img,(0,0)-(ShadowWidth-1,ShadowWidth-1),&H00FFFFFF,BF  
  for i as integer=0 to ShadowWidth-1
    alphavalue=int((1 - i/(ShadowWidth-1))*maxalpha) shl 24    
    for k as integer=0 to numrays
      radian=k*radianstep
      x=cos(radian)*i
      y=sin(radian)*i
      pset ShadowCTL->img,(ShadowWidth-1-x,ShadowWidth-1-y), alphavalue or Colors.Black
      pset ShadowCTR->img,(x,ShadowWidth-1-y), alphavalue or Colors.Black
      pset ShadowCBL->img,(ShadowWidth-1-x,y), alphavalue or Colors.Black
      pset ShadowCBR->img,(x,y), alphavalue or Colors.Black     
    next k
  next i
  
  for i as integer=0 to ShadowWidth-1
    alphavalue=int(i/(ShadowWidth-1) * maxalpha) shl 24 
    pset ShadowLeft->img,(i,0), alphavalue or Colors.Black
    pset ShadowRight->img,(ShadowWidth-1-i,0), alphavalue or Colors.Black
    pset ShadowTop->img,(0,i), alphavalue or Colors.Black
    pset ShadowBottom->img,(0,ShadowWidth-1-i), alphavalue or Colors.Black    
  next i
end sub


sub WinShadow (img as FB.Image ptr,PosX as integer,PosY as integer,BoxWidth as integer,BoxHeight as integer)
  dim as integer x0,x1,x2,x3,y0,y1,y2,y3,w,h
  x0=PosX-ShadowWidth*.40
  x1=x0+ShadowWidth
  x2=PosX+BoxWidth - ShadowWidth + ShadowWidth*.66
  
  y0=PosY-ShadowWidth*.40
  y1=y0+ShadowWidth
  y2=PosY+BoxHeight
  w=x2 - x1
  h=y2 - y1
  if img then
    
    for i as integer=0 to w-1 step 1
      put img,(x1 + i, y0),ShadowTop->img,alpha   
      put img,(x1 + i, y2),ShadowBottom->img,alpha   
    next i
    for i as integer=0 to h-1 step 1
      put img,(x0, y1 + i),ShadowLeft->img,alpha   
      put img,(x2, y1 + i),ShadowRight->img,alpha   
    next i  

    put img,(x0, y0),ShadowCTL->img,alpha
    put img,(x2, y0),ShadowCTR->img,alpha
    put img,(x0, y2),ShadowCBL->img,alpha
    put img,(x2, y2),ShadowCBR->img,alpha 
  
  else
  
    for i as integer=0 to w-1 step 1
      put (x1 + i, y0),ShadowTop->img,alpha   
      put (x1 + i, y2),ShadowBottom->img,alpha   
    next i
    for i as integer=0 to h-1 step 1
      put (x0, y1 + i),ShadowLeft->img,alpha   
      put (x2, y1 + i),ShadowRight->img,alpha   
    next i  

    put (x0, y0),ShadowCTL->img,alpha
    put (x2, y0),ShadowCTR->img,alpha
    put (x0, y2),ShadowCBL->img,alpha
    put (x2, y2),ShadowCBR->img,alpha
    
  end if
end sub
